//-------------------------------------------------------------------
//
//   This file is automatically generated by VHDL to Verilog Translator.
//         Ver.1.20 Build Mar.18.2005
//               www.sugawara-systems.com   
//                    tech-support@sugawara-systems.com
//        See Original Copyright Notice for property of the file .( somewhere in this file.)
//
//--------------------------------------------------------------------


//-------------------------------------------------------------------
// TITLE: Test Bench
// AUTHOR: Steve Rhoads (rhoadss@yahoo.com)
// DATE CREATED: 4/21/01
// FILENAME: tbench.vhd
// PROJECT: Plasma CPU core
// COPYRIGHT: Software placed into the public domain by the author.
//    Software 'as is' without warranty.  Author liable for nothing.
// DESCRIPTION:
//    This entity provides a test bench for testing the Plasma CPU core.
//-------------------------------------------------------------------

`timescale 1ns/1ns
`define ns 1
`define us (1000*`ns)
`define ms (1000*`us)
`define sec (1000*`ms)

module  tbench; // Null Port List
         parameter [31:0] zero=32'b00000000000000000000000000000000;
     parameter [31:0] ones=32'b11111111111111111111111111111111;
     parameter [31:0] high_z=32'bZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ;
     parameter [3:0] alu_nothing=4'b0000;
     parameter [3:0] alu_add=4'b0001;
     parameter [3:0] alu_subtract=4'b0010;
     parameter [3:0] alu_less_than=4'b0011;
     parameter [3:0] alu_less_than_signed=4'b0100;
     parameter [3:0] alu_or=4'b0101;
     parameter [3:0] alu_and=4'b0110;
     parameter [3:0] alu_xor=4'b0111;
     parameter [3:0] alu_nor=4'b1000;
     parameter [1:0] shift_nothing=2'b00;
     parameter [1:0] shift_left_unsigned=2'b01;
     parameter [1:0] shift_right_signed=2'b11;
     parameter [1:0] shift_right_unsigned=2'b10;
     parameter [3:0] mult_nothing=4'b0000;
     parameter [3:0] mult_read_lo=4'b0001;
     parameter [3:0] mult_read_hi=4'b0010;
     parameter [3:0] mult_write_lo=4'b0011;
     parameter [3:0] mult_write_hi=4'b0100;
     parameter [3:0] mult_mult=4'b0101;
     parameter [3:0] mult_signed_mult=4'b0110;
     parameter [3:0] mult_divide=4'b0111;
     parameter [3:0] mult_signed_divide=4'b1000;
     parameter [1:0] a_from_reg_source=2'b00;
     parameter [1:0] a_from_imm10_6=2'b01;
     parameter [1:0] a_from_pc=2'b10;
     parameter [1:0] b_from_reg_target=2'b00;
     parameter [1:0] b_from_imm=2'b01;
     parameter [1:0] b_from_signed_imm=2'b10;
     parameter [1:0] b_from_immx4=2'b11;
     parameter [2:0] c_from_null=3'b000;
     parameter [2:0] c_from_alu=3'b001;
     parameter [2:0] c_from_shift=3'b001;
     parameter [2:0] c_from_mult=3'b001;
     parameter [2:0] c_from_memory=3'b010;
     parameter [2:0] c_from_pc=3'b011;
     parameter [2:0] c_from_pc_plus4=3'b100;
     parameter [2:0] c_from_imm_shift16=3'b101;
     parameter [2:0] c_from_reg_sourcen=3'b110;
     parameter [1:0] from_inc4=2'b00;
     parameter [1:0] from_opcode25_0=2'b01;
     parameter [1:0] from_branch=2'b10;
     parameter [1:0] from_lbranch=2'b11;
     parameter [2:0] branch_ltz=3'b000;
     parameter [2:0] branch_lez=3'b001;
     parameter [2:0] branch_eq=3'b010;
     parameter [2:0] branch_ne=3'b011;
     parameter [2:0] branch_gez=3'b100;
     parameter [2:0] branch_gtz=3'b101;
     parameter [2:0] branch_yes=3'b110;
     parameter [3:0] mem_fetch=4'b0000;
     parameter [3:0] mem_read32=4'b0100;
     parameter [3:0] mem_write32=4'b0101;
     parameter [3:0] mem_read16=4'b1000;
     parameter [3:0] mem_read16s=4'b1010;
     parameter [3:0] mem_write16=4'b1001;
     parameter [3:0] mem_read8=4'b1100;
     parameter [3:0] mem_read8s=4'b1110;
     parameter [3:0] mem_write8=4'b1101;


    parameter memory_type = "GENERIC";//constant 
    parameter log_file = "output.txt";//constant 
    reg clk;
   initial clk = 1'b1;
    reg reset;
   initial reset = 1'b1;
    reg interrupt;
   initial interrupt = 1'b0;
    wire mem_write;
    wire [31:0] mem_address;
    wire [31:0] mem_data;
    reg mem_pause;
   initial mem_pause = 1'b0;
    wire [3:0] mem_byte_sel;
    wire uart_read;
    wire uart_write;

       
   always #(50* `ns) {clk}<=~ (clk);
   
       initial begin 
                   #(500* `ns) {reset}<=1'b0;
			#(5000000 *`ns) $finish;//TAK Mar.19.2005
       end//end initial
   
   plasma  #(.memory_type(memory_type),.log_file(log_file)) u1(.clk_in(clk), .reset_in(reset), .intr_in(interrupt), .uart_read(uart_read), .uart_write(uart_write), .mem_address_out(mem_address), .mem_data(mem_data), .mem_byte_sel_out(mem_byte_sel), .mem_write_out(mem_write), .mem_pause_in(mem_pause));
   //Parameter Order: memory_type,log_file 
       
   
endmodule
//-------------------------------------------------------------------
// TITLE: Shifter Unit
// AUTHOR: Steve Rhoads (rhoadss@yahoo.com)
//         Matthias Gruenewald
// DATE CREATED: 2/2/01
// FILENAME: shifter.vhd
// PROJECT: Plasma CPU core
// COPYRIGHT: Software placed into the public domain by the author.
//    Software 'as is' without warranty.  Author liable for nothing.
// DESCRIPTION:
//    Implements the 32-bit shifter unit.
//-------------------------------------------------------------------


module  shifter ( value, shift_amount, shift_func, c_shift );
parameter shifter_type="GENERIC";
         parameter [31:0] zero=32'b00000000000000000000000000000000;
     parameter [31:0] ones=32'b11111111111111111111111111111111;
     parameter [31:0] high_z=32'bZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ;
     parameter [3:0] alu_nothing=4'b0000;
     parameter [3:0] alu_add=4'b0001;
     parameter [3:0] alu_subtract=4'b0010;
     parameter [3:0] alu_less_than=4'b0011;
     parameter [3:0] alu_less_than_signed=4'b0100;
     parameter [3:0] alu_or=4'b0101;
     parameter [3:0] alu_and=4'b0110;
     parameter [3:0] alu_xor=4'b0111;
     parameter [3:0] alu_nor=4'b1000;
     parameter [1:0] shift_nothing=2'b00;
     parameter [1:0] shift_left_unsigned=2'b01;
     parameter [1:0] shift_right_signed=2'b11;
     parameter [1:0] shift_right_unsigned=2'b10;
     parameter [3:0] mult_nothing=4'b0000;
     parameter [3:0] mult_read_lo=4'b0001;
     parameter [3:0] mult_read_hi=4'b0010;
     parameter [3:0] mult_write_lo=4'b0011;
     parameter [3:0] mult_write_hi=4'b0100;
     parameter [3:0] mult_mult=4'b0101;
     parameter [3:0] mult_signed_mult=4'b0110;
     parameter [3:0] mult_divide=4'b0111;
     parameter [3:0] mult_signed_divide=4'b1000;
     parameter [1:0] a_from_reg_source=2'b00;
     parameter [1:0] a_from_imm10_6=2'b01;
     parameter [1:0] a_from_pc=2'b10;
     parameter [1:0] b_from_reg_target=2'b00;
     parameter [1:0] b_from_imm=2'b01;
     parameter [1:0] b_from_signed_imm=2'b10;
     parameter [1:0] b_from_immx4=2'b11;
     parameter [2:0] c_from_null=3'b000;
     parameter [2:0] c_from_alu=3'b001;
     parameter [2:0] c_from_shift=3'b001;
     parameter [2:0] c_from_mult=3'b001;
     parameter [2:0] c_from_memory=3'b010;
     parameter [2:0] c_from_pc=3'b011;
     parameter [2:0] c_from_pc_plus4=3'b100;
     parameter [2:0] c_from_imm_shift16=3'b101;
     parameter [2:0] c_from_reg_sourcen=3'b110;
     parameter [1:0] from_inc4=2'b00;
     parameter [1:0] from_opcode25_0=2'b01;
     parameter [1:0] from_branch=2'b10;
     parameter [1:0] from_lbranch=2'b11;
     parameter [2:0] branch_ltz=3'b000;
     parameter [2:0] branch_lez=3'b001;
     parameter [2:0] branch_eq=3'b010;
     parameter [2:0] branch_ne=3'b011;
     parameter [2:0] branch_gez=3'b100;
     parameter [2:0] branch_gtz=3'b101;
     parameter [2:0] branch_yes=3'b110;
     parameter [3:0] mem_fetch=4'b0000;
     parameter [3:0] mem_read32=4'b0100;
     parameter [3:0] mem_write32=4'b0101;
     parameter [3:0] mem_read16=4'b1000;
     parameter [3:0] mem_read16s=4'b1010;
     parameter [3:0] mem_write16=4'b1001;
     parameter [3:0] mem_read8=4'b1100;
     parameter [3:0] mem_read8s=4'b1110;
     parameter [3:0] mem_write8=4'b1101;

    input [31:0]  value ;
    input [4:0]  shift_amount ;
    input [1:0]  shift_func ;
    output [31:0]  c_shift ;


    wire [31:0] shift1l;
    wire [31:0] shift2l;
    wire [31:0] shift4l;
    wire [31:0] shift8l;
    wire [31:0] shift16l;
    wire [31:0] shift1r;
    wire [31:0] shift2r;
    wire [31:0] shift4r;
    wire [31:0] shift8r;
    wire [31:0] shift16r;
    wire [31:16] fills;
    wire [31:0] c_shift;


    
   assign {fills}=((shift_func === shift_right_signed) & (value[31] === 1'b1)) ? 
                      16'b1111111111111111
                   :  16'b0000000000000000;
   
   assign {shift1l}=(shift_amount[0] === 1'b1) ? 
                        {value[30:0],1'b0}
                     :  value;
   
   assign {shift2l}=(shift_amount[1] === 1'b1) ? 
                        {shift1l[29:0],2'b00}
                     :  shift1l;
   
   assign {shift4l}=(shift_amount[2] === 1'b1) ? 
                        {shift2l[27:0],4'b0000}
                     :  shift2l;
   
   assign {shift8l}=(shift_amount[3] === 1'b1) ? 
                        {shift4l[23:0],8'b00000000}
                     :  shift4l;
   
   assign {shift16l}=(shift_amount[4] === 1'b1) ? 
                         {shift8l[15:0],zero[15:0]}
                      :  shift8l;
   
   assign {shift1r}=(shift_amount[0] === 1'b1) ? 
                        {fills[31],value[31:1]}
                     :  value;
   
   assign {shift2r}=(shift_amount[1] === 1'b1) ? 
                        {fills[31:30],shift1r[31:2]}
                     :  shift1r;
   
   assign {shift4r}=(shift_amount[2] === 1'b1) ? 
                        {fills[31:28],shift2r[31:4]}
                     :  shift2r;
   
   assign {shift8r}=(shift_amount[3] === 1'b1) ? 
                        {fills[31:24],shift4r[31:8]}
                     :  shift4r;
   
   assign {shift16r}=(shift_amount[4] === 1'b1) ? 
                         {fills[31:16],shift8r[31:16]}
                      :  shift8r;
   
   
   generate
       if ((shifter_type === "GENERIC"))begin//generate if 
               
           assign {c_shift}=(shift_func === shift_left_unsigned) ? 
                                shift16l
                             : ((shift_func === shift_right_unsigned) | (shift_func === shift_right_signed)) ? 
                                shift16r
                             :  32'b00000000000000000000000000000000;
           
       end//generate if
   endgenerate
   
   
   generate
       if ((shifter_type === "AREA_OPTIMIZED"))begin//generate if 
               
           assign {c_shift}=(shift_func === shift_left_unsigned) ? 
                                shift16l
                             :  {(31-0+1- 0){1'bz}};
           
           assign {c_shift}=((shift_func === shift_right_unsigned) | (shift_func === shift_right_signed)) ? 
                                shift16r
                             :  {(31-0+1- 0){1'bz}};
           
           assign {c_shift}=(shift_func === shift_nothing) ? 
                                32'b00000000000000000000000000000000
                             :  {(31-0+1- 0){1'bz}};
           
       end//generate if
   endgenerate
    

endmodule
//-------------------------------------------------------------------
// TITLE: Register Bank
// AUTHOR: Steve Rhoads (rhoadss@yahoo.com)
// DATE CREATED: 2/2/01
// FILENAME: reg_bank.vhd
// PROJECT: Plasma CPU core
// COPYRIGHT: Software placed into the public domain by the author.
//    Software 'as is' without warranty.  Author liable for nothing.
// DESCRIPTION:
//    Implements a register bank with 32 registers that are 32-bits wide.
//    There are two read-ports and one write port.
//-------------------------------------------------------------------


module  reg_bank ( clk, reset_in, pause, rs_index, rt_index, rd_index, reg_source_out, reg_target_out, reg_dest_new, intr_enable );
parameter memory_type="GENERIC";
         parameter [31:0] zero=32'b00000000000000000000000000000000;
     parameter [31:0] ones=32'b11111111111111111111111111111111;
     parameter [31:0] high_z=32'bZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ;
     parameter [3:0] alu_nothing=4'b0000;
     parameter [3:0] alu_add=4'b0001;
     parameter [3:0] alu_subtract=4'b0010;
     parameter [3:0] alu_less_than=4'b0011;
     parameter [3:0] alu_less_than_signed=4'b0100;
     parameter [3:0] alu_or=4'b0101;
     parameter [3:0] alu_and=4'b0110;
     parameter [3:0] alu_xor=4'b0111;
     parameter [3:0] alu_nor=4'b1000;
     parameter [1:0] shift_nothing=2'b00;
     parameter [1:0] shift_left_unsigned=2'b01;
     parameter [1:0] shift_right_signed=2'b11;
     parameter [1:0] shift_right_unsigned=2'b10;
     parameter [3:0] mult_nothing=4'b0000;
     parameter [3:0] mult_read_lo=4'b0001;
     parameter [3:0] mult_read_hi=4'b0010;
     parameter [3:0] mult_write_lo=4'b0011;
     parameter [3:0] mult_write_hi=4'b0100;
     parameter [3:0] mult_mult=4'b0101;
     parameter [3:0] mult_signed_mult=4'b0110;
     parameter [3:0] mult_divide=4'b0111;
     parameter [3:0] mult_signed_divide=4'b1000;
     parameter [1:0] a_from_reg_source=2'b00;
     parameter [1:0] a_from_imm10_6=2'b01;
     parameter [1:0] a_from_pc=2'b10;
     parameter [1:0] b_from_reg_target=2'b00;
     parameter [1:0] b_from_imm=2'b01;
     parameter [1:0] b_from_signed_imm=2'b10;
     parameter [1:0] b_from_immx4=2'b11;
     parameter [2:0] c_from_null=3'b000;
     parameter [2:0] c_from_alu=3'b001;
     parameter [2:0] c_from_shift=3'b001;
     parameter [2:0] c_from_mult=3'b001;
     parameter [2:0] c_from_memory=3'b010;
     parameter [2:0] c_from_pc=3'b011;
     parameter [2:0] c_from_pc_plus4=3'b100;
     parameter [2:0] c_from_imm_shift16=3'b101;
     parameter [2:0] c_from_reg_sourcen=3'b110;
     parameter [1:0] from_inc4=2'b00;
     parameter [1:0] from_opcode25_0=2'b01;
     parameter [1:0] from_branch=2'b10;
     parameter [1:0] from_lbranch=2'b11;
     parameter [2:0] branch_ltz=3'b000;
     parameter [2:0] branch_lez=3'b001;
     parameter [2:0] branch_eq=3'b010;
     parameter [2:0] branch_ne=3'b011;
     parameter [2:0] branch_gez=3'b100;
     parameter [2:0] branch_gtz=3'b101;
     parameter [2:0] branch_yes=3'b110;
     parameter [3:0] mem_fetch=4'b0000;
     parameter [3:0] mem_read32=4'b0100;
     parameter [3:0] mem_write32=4'b0101;
     parameter [3:0] mem_read16=4'b1000;
     parameter [3:0] mem_read16s=4'b1010;
     parameter [3:0] mem_write16=4'b1001;
     parameter [3:0] mem_read8=4'b1100;
     parameter [3:0] mem_read8s=4'b1110;
     parameter [3:0] mem_write8=4'b1101;

    input clk;
    input reset_in;
    input pause;
    input [5:0]  rs_index ;
    input [5:0]  rt_index ;
    input [5:0]  rd_index ;
    output [31:0]  reg_source_out ;
    output [31:0]  reg_target_out ;
    input [31:0]  reg_dest_new ;
    output intr_enable;


    reg intr_enable_reg;
    reg [4:0] addr_a1;
    reg [4:0] addr_a2;
    reg [4:0] addr_b;
    reg /* conflict */[31:0] data_out1_=32'bz;
    wire /* conflict */[31:0] data_out1;
    reg /* conflict */[31:0] data_out2_=32'bz;
    wire /* conflict */[31:0] data_out2;
    reg write_enable;
    reg [31:0] reg_source_out;
    reg [31:0] reg_target_out;
    reg intr_enable;


    
   always @ (posedge clk or posedge reset_in ) begin
       if ((reset_in === 1'b1)) 
           intr_enable_reg <= 1'b0;
           
       else 
           begin 
               if ((rd_index === 6'b101110)) 
                   intr_enable_reg <= 1'b0;
                   
               else if ((rd_index === 6'b101100)) 
                   intr_enable_reg <= reg_dest_new[0];
                   
               
               
           end 
       
   end //always
       
   always @ (clk or rs_index or rt_index or rd_index or reg_dest_new or intr_enable_reg or data_out1 or data_out2 or reset_in or pause ) begin
       begin 
           if ((rs_index === 6'b101110)) 
               addr_a1 <= 5'b00000;
               
           else 
               addr_a1 <= rs_index[4:0];
               
           case (rs_index)
               6'b000000 : 
                       reg_source_out <= 32'b00000000000000000000000000000000;
               6'b101100 : 
                       reg_source_out <= {zero[31:1],intr_enable_reg};
               6'b111111 : 
                       reg_source_out <= {zero[31:8],8'b00111100};
               default : 
                       reg_source_out <= data_out1;
           endcase
           addr_a2 <= rt_index[4:0];
           case (rt_index)
               6'b000000 : 
                       reg_target_out <= 32'b00000000000000000000000000000000;
               default : 
                       reg_target_out <= data_out2;
           endcase
           if ((((!(rd_index===6'b000000)) & (!(rd_index===6'b101100))) & (pause === 1'b0))) 
               write_enable <= 1'b1;
               
           else 
               write_enable <= 1'b0;
               
           if ((rd_index === 6'b101110)) 
               addr_b <= 5'b00000;
               
           else 
               addr_b <= rd_index[4:0];
               
           intr_enable <= intr_enable_reg;
       end 
   end //always
   
   
   generate
       if ((memory_type === "GENERIC"))begin//generate if 
                   reg [31:0] ram_proc__tri_port_ram [31:0];
               
           always @ (posedge clk ) begin
                   begin 
                       if ((write_enable === 1'b1)) 
                           ram_proc__tri_port_ram[addr_b] = reg_dest_new;
                           
                       
                       
                   end 
               
           end //always
               
           always @ (clk or addr_a1 or addr_a2 or addr_b or reg_dest_new or write_enable ) begin
               begin 
                   data_out1_ <= ram_proc__tri_port_ram[addr_a1];
                   data_out2_ <= ram_proc__tri_port_ram[addr_a2];
                   
               end 
           end //always
           
       end//generate if
   endgenerate
   
   
   generate
       if ((memory_type === "DUAL_PORT"))begin//generate if 
                   reg [31:0] ram_proc2__dual_port_ram1 [31:0];
    reg [31:0] ram_proc2__dual_port_ram2 [31:0];
               
           always @ (posedge clk ) begin
                   begin 
                       if ((write_enable === 1'b1)) 
                           begin 
                               ram_proc2__dual_port_ram1[addr_b] = reg_dest_new;
                               ram_proc2__dual_port_ram2[addr_b] = reg_dest_new;
                           end
                           
                       
                       
                   end 
               
           end //always
               
           always @ (clk or addr_a1 or addr_a2 or addr_b or reg_dest_new or write_enable ) begin
               begin 
                   data_out1_ <= ram_proc2__dual_port_ram1[addr_a1];
                   data_out2_ <= ram_proc2__dual_port_ram2[addr_a2];
                   
               end 
           end //always
           
       end//generate if
   endgenerate
   
   
   generate
       if ((memory_type === "DUAL_PORT_XILINX"))begin//generate if 
               
           reg_file_dp_ram reg_file_dp_ram_1(.addra(addr_a1), .addrb(addr_b), .clka(clk), .clkb(clk), .dinb(reg_dest_new), .douta(data_out1), .web(write_enable));
           
           reg_file_dp_ram reg_file_dp_ram_2(.addra(addr_a2), .addrb(addr_b), .clka(clk), .clkb(clk), .dinb(reg_dest_new), .douta(data_out2), .web(write_enable));
           
       end//generate if
   endgenerate
   
   
   generate
       if ((memory_type === "DUAL_PORT_XILINX_XC4000XLA"))begin//generate if 
               
           reg_file_dp_ram_xc4000xla reg_file_dp_ram_1(.a(addr_b), .di(reg_dest_new), .wr_en(write_enable), .wr_clk(clk), .dpra(addr_a1), .spo(/*open */), .dpo(data_out1));
           
           reg_file_dp_ram_xc4000xla reg_file_dp_ram_2(.a(addr_b), .di(reg_dest_new), .wr_en(write_enable), .wr_clk(clk), .dpra(addr_a2), .spo(/*open */), .dpo(data_out2));
           
       end//generate if
   endgenerate
   
   
   generate
       if ((memory_type === "ALTERA"))begin//generate if 
               
           lpm_ram_dp  #(.lpm_width(32),.lpm_widthad(5),.rden_used("FALSE"),.intended_device_family("UNUSED"),.lpm_indata("REGISTERED"),.lpm_wraddress_control("REGISTERED"),.lpm_rdaddress_control("UNREGISTERED"),.lpm_outdata("UNREGISTERED"),.use_eab("ON"),.lpm_type("LPM_RAM_DP")) lpm_ram_dp_component1(.wren(write_enable), .wrclock(clk), .q(data_out1), .data(reg_dest_new), .rdaddress(addr_a1), .wraddress(addr_b));
           //Parameter Order: lpm_width,lpm_widthad,rden_used,intended_device_family,lpm_indata,lpm_wraddress_control,lpm_rdaddress_control,lpm_outdata,use_eab,lpm_type 

           lpm_ram_dp  #(.lpm_width(32),.lpm_widthad(5),.rden_used("FALSE"),.intended_device_family("UNUSED"),.lpm_indata("REGISTERED"),.lpm_wraddress_control("REGISTERED"),.lpm_rdaddress_control("UNREGISTERED"),.lpm_outdata("UNREGISTERED"),.use_eab("ON"),.lpm_type("LPM_RAM_DP")) lpm_ram_dp_component2(.wren(write_enable), .wrclock(clk), .q(data_out2), .data(reg_dest_new), .rdaddress(addr_a2), .wraddress(addr_b));
           //Parameter Order: lpm_width,lpm_widthad,rden_used,intended_device_family,lpm_indata,lpm_wraddress_control,lpm_rdaddress_control,lpm_outdata,use_eab,lpm_type 
       end//generate if
   endgenerate
        assign data_out1 = data_out1_;//Added for Conflict reslover.
    assign data_out2 = data_out2_;//Added for Conflict reslover.
    

endmodule
//-------------------------------------------------------------------
// TITLE: Random Access Memory
// AUTHOR: Steve Rhoads (rhoadss@yahoo.com)
// DATE CREATED: 4/21/01
// FILENAME: ram.vhd
// PROJECT: Plasma CPU core
// COPYRIGHT: Software placed into the public domain by the author.
//    Software 'as is' without warranty.  Author liable for nothing.
// DESCRIPTION:
//    Implements the RAM, reads the executable from either "code.txt",
//    or for Altera "code[0-3].hex".
//    Modified from "The Designer's Guide to VHDL" by Peter J. Ashenden
//-------------------------------------------------------------------


module  ram ( clk, mem_byte_sel, mem_write, mem_address, mem_data_w, mem_data_r );
parameter memory_type="GENERIC";
    //type strength
     parameter strn_x01__strength=4'd0;
     parameter strn_x0h__strength=4'd1;
     parameter strn_xl1__strength=4'd2;
     parameter strn_x0z__strength=4'd3;
     parameter strn_xz1__strength=4'd4;
     parameter strn_wlh__strength=4'd5;
     parameter strn_wlz__strength=4'd6;
     parameter strn_wzh__strength=4'd7;
     parameter strn_w0h__strength=4'd8;
     parameter strn_wl1__strength=4'd9;
     
 parameter [31:0] zero=32'b00000000000000000000000000000000;
 parameter [31:0] ones=32'b11111111111111111111111111111111;
 parameter [31:0] high_z=32'bZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ;
 parameter [3:0] alu_nothing=4'b0000;
 parameter [3:0] alu_add=4'b0001;
 parameter [3:0] alu_subtract=4'b0010;
 parameter [3:0] alu_less_than=4'b0011;
 parameter [3:0] alu_less_than_signed=4'b0100;
 parameter [3:0] alu_or=4'b0101;
 parameter [3:0] alu_and=4'b0110;
 parameter [3:0] alu_xor=4'b0111;
 parameter [3:0] alu_nor=4'b1000;
 parameter [1:0] shift_nothing=2'b00;
 parameter [1:0] shift_left_unsigned=2'b01;
 parameter [1:0] shift_right_signed=2'b11;
 parameter [1:0] shift_right_unsigned=2'b10;
 parameter [3:0] mult_nothing=4'b0000;
 parameter [3:0] mult_read_lo=4'b0001;
 parameter [3:0] mult_read_hi=4'b0010;
 parameter [3:0] mult_write_lo=4'b0011;
 parameter [3:0] mult_write_hi=4'b0100;
 parameter [3:0] mult_mult=4'b0101;
 parameter [3:0] mult_signed_mult=4'b0110;
 parameter [3:0] mult_divide=4'b0111;
 parameter [3:0] mult_signed_divide=4'b1000;
 parameter [1:0] a_from_reg_source=2'b00;
 parameter [1:0] a_from_imm10_6=2'b01;
 parameter [1:0] a_from_pc=2'b10;
 parameter [1:0] b_from_reg_target=2'b00;
 parameter [1:0] b_from_imm=2'b01;
 parameter [1:0] b_from_signed_imm=2'b10;
 parameter [1:0] b_from_immx4=2'b11;
 parameter [2:0] c_from_null=3'b000;
 parameter [2:0] c_from_alu=3'b001;
 parameter [2:0] c_from_shift=3'b001;
 parameter [2:0] c_from_mult=3'b001;
 parameter [2:0] c_from_memory=3'b010;
 parameter [2:0] c_from_pc=3'b011;
 parameter [2:0] c_from_pc_plus4=3'b100;
 parameter [2:0] c_from_imm_shift16=3'b101;
 parameter [2:0] c_from_reg_sourcen=3'b110;
 parameter [1:0] from_inc4=2'b00;
 parameter [1:0] from_opcode25_0=2'b01;
 parameter [1:0] from_branch=2'b10;
 parameter [1:0] from_lbranch=2'b11;
 parameter [2:0] branch_ltz=3'b000;
 parameter [2:0] branch_lez=3'b001;
 parameter [2:0] branch_eq=3'b010;
 parameter [2:0] branch_ne=3'b011;
 parameter [2:0] branch_gez=3'b100;
 parameter [2:0] branch_gtz=3'b101;
 parameter [2:0] branch_yes=3'b110;
 parameter [3:0] mem_fetch=4'b0000;
 parameter [3:0] mem_read32=4'b0100;
 parameter [3:0] mem_write32=4'b0101;
 parameter [3:0] mem_read16=4'b1000;
 parameter [3:0] mem_read16s=4'b1010;
 parameter [3:0] mem_write16=4'b1001;
 parameter [3:0] mem_read8=4'b1100;
 parameter [3:0] mem_read8s=4'b1110;
 parameter [3:0] mem_write8=4'b1101;

    input clk;
    input [3:0]  mem_byte_sel ;
    input mem_write;
    input [31:0]  mem_address ;
    input [31:0]  mem_data_w ;
    output [31:0]  mem_data_r ;


    parameter address_width = 13;//constant 
    wire clk_inv;
    wire mem_sel;
    wire read_enable;
    wire [3:0] write_byte_enable;
    reg /* conflict */[31:0] mem_data_r_=32'bz;
    wire /* conflict */[31:0] mem_data_r;


    
   assign {clk_inv}=~ (clk);
   
   assign {mem_sel}=(mem_address[30:address_width] === zero[30:address_width]) ? 
                        1'b1
                     :  1'b0;
   
   assign {read_enable}=(mem_sel & ~ (mem_write));
   
   assign {write_byte_enable}=(mem_sel === 1'b1) ? 
                                  mem_byte_sel
                               :  4'b0000;
   
    parameter ram_proc__mem_size = (2<< (address_width-1));//Mar.19.2005
   generate
       if ((memory_type === "GENERIC"))begin//generate if 
                 
    reg [31:0] ram_proc__data;
    reg [((31-0+1) - 1):0] ram_proc__storage [0:((ram_proc__mem_size / 4) - 1)];
    integer ram_proc__index = 0;
integer ram_proc__load_file;
   initial begin
           ram_proc__load_file=$fopen("code_org.txt","r+");//TAK Mar.19.2005
   end
line_vhdl ram_proc__hex_file_line;
               
           always @ (posedge clk ) begin
                   begin 
                       if ((mem_write === 1'b1)) 
                           ram_proc__storage[ram_proc__index] = ram_proc__data;
                           
                       
                       
                   end 
               
           end //always
               
           always @ (clk or mem_byte_sel or mem_write or mem_address or mem_data_w or mem_sel ) begin
               begin 
                   if ((ram_proc__index === 0)) 
                           while ( ~ ($feof(ram_proc__load_file))) 
                           begin 
                               begin 
                                   $readline(ram_proc__load_file, ram_proc__hex_file_line);
                                    $read_std_logich_vector(ram_proc__hex_file_line, ram_proc__data);
                                   ram_proc__storage[ram_proc__index] = ram_proc__data;
                                   ram_proc__index = (ram_proc__index + 1);
                               end
                               
                           end //while
                       
                       
                   ram_proc__index = mem_address[(address_width - 1):2];
                   ram_proc__data = ram_proc__storage[ram_proc__index];
                   if ((mem_sel === 1'b1)) 
                       begin 
                           begin 
                               if ((mem_write === 1'b0)) 
                                   mem_data_r_ <= ram_proc__data;
                                   
                               
                               if ((mem_byte_sel[0] === 1'b1)) 
                                   ram_proc__data[7:0] = mem_data_w[7:0];
                                   
                               
                               if ((mem_byte_sel[1] === 1'b1)) 
                                   ram_proc__data[15:8] = mem_data_w[15:8];
                                   
                               
                               if ((mem_byte_sel[2] === 1'b1)) 
                                   ram_proc__data[23:16] = mem_data_w[23:16];
                                   
                               
                               if ((mem_byte_sel[3] === 1'b1)) 
                                   ram_proc__data[31:24] = mem_data_w[31:24];
                                   
                               
                               
                           end
                           
                       end 
                   
               end 
           end //always
           
       end//generate if
   endgenerate
   
   
   generate
       if ((memory_type === "ALTERA"))begin//generate if 
               
           lpm_ram_dq  #(.lpm_width(8),.lpm_widthad((address_width - 2)) /* 0 */ ,.lpm_indata("REGISTERED"),.lpm_address_control("REGISTERED"),.lpm_outdata("UNREGISTERED"),.lpm_file("code0.hex"),.lpm_type("LPM_RAM_DQ"),.use_eab("ON"),.intended_device_family("UNUSED") /* "UNUSED" */ ) lpm_ram_io_component0(.data(mem_data_w[31:24]), .address(mem_address[(address_width - 1):2]), .inclock(clk_inv), .outclock(/*open */), .we(write_byte_enable[3]), .q(mem_data_r[31:24]));
           //Parameter Order: lpm_width,lpm_widthad,lpm_numwords,lpm_indata,lpm_address_control,lpm_outdata,lpm_file,lpm_type,use_eab,intended_device_family,lpm_hint 

           lpm_ram_dq  #(.lpm_width(8),.lpm_widthad((address_width - 2)) /* 0 */ ,.lpm_indata("REGISTERED"),.lpm_address_control("REGISTERED"),.lpm_outdata("UNREGISTERED"),.lpm_file("code1.hex"),.lpm_type("LPM_RAM_DQ"),.use_eab("ON"),.intended_device_family("UNUSED") /* "UNUSED" */ ) lpm_ram_io_component1(.data(mem_data_w[23:16]), .address(mem_address[(address_width - 1):2]), .inclock(clk_inv), .outclock(/*open */), .we(write_byte_enable[2]), .q(mem_data_r[23:16]));
           //Parameter Order: lpm_width,lpm_widthad,lpm_numwords,lpm_indata,lpm_address_control,lpm_outdata,lpm_file,lpm_type,use_eab,intended_device_family,lpm_hint 

           lpm_ram_dq  #(.lpm_width(8),.lpm_widthad((address_width - 2)) /* 0 */ ,.lpm_indata("REGISTERED"),.lpm_address_control("REGISTERED"),.lpm_outdata("UNREGISTERED"),.lpm_file("code2.hex"),.lpm_type("LPM_RAM_DQ"),.use_eab("ON"),.intended_device_family("UNUSED") /* "UNUSED" */ ) lpm_ram_io_component2(.data(mem_data_w[15:8]), .address(mem_address[(address_width - 1):2]), .inclock(clk_inv), .outclock(/*open */), .we(write_byte_enable[1]), .q(mem_data_r[15:8]));
           //Parameter Order: lpm_width,lpm_widthad,lpm_numwords,lpm_indata,lpm_address_control,lpm_outdata,lpm_file,lpm_type,use_eab,intended_device_family,lpm_hint 

           lpm_ram_dq  #(.lpm_width(8),.lpm_widthad((address_width - 2)) /* 0 */ ,.lpm_indata("REGISTERED"),.lpm_address_control("REGISTERED"),.lpm_outdata("UNREGISTERED"),.lpm_file("code3.hex"),.lpm_type("LPM_RAM_DQ"),.use_eab("ON"),.intended_device_family("UNUSED") /* "UNUSED" */ ) lpm_ram_io_component3(.data(mem_data_w[7:0]), .address(mem_address[(address_width - 1):2]), .inclock(clk_inv), .outclock(/*open */), .we(write_byte_enable[0]), .q(mem_data_r[7:0]));
           //Parameter Order: lpm_width,lpm_widthad,lpm_numwords,lpm_indata,lpm_address_control,lpm_outdata,lpm_file,lpm_type,use_eab,intended_device_family,lpm_hint 
       end//generate if
   endgenerate
                                           assign mem_data_r = mem_data_r_;//Added for Conflict reslover.
                                       
                                   
endmodule
//-------------------------------------------------------------------
// TITLE: Plamsa Interface (clock divider and interface to FPGA board)
// AUTHOR: Steve Rhoads (rhoadss@yahoo.com)
// DATE CREATED: 6/6/02
// FILENAME: plasma_if.vhd
// PROJECT: Plasma CPU core
// COPYRIGHT: Software placed into the public domain by the author.
//    Software 'as is' without warranty.  Author liable for nothing.
// DESCRIPTION:
//    This entity divides the clock by two and interfaces to the 
//    Altera EP20K200EFC484-2X FPGA board.
//-------------------------------------------------------------------


module  plasma_if ( clk_in, reset_n, uart_read, uart_write, address, data, we_n, oe_n, be_n, sram0_cs_n, sram1_cs_n );
parameter memory_type="ALTERA";
parameter log_file="UNUSED";
         parameter [31:0] zero=32'b00000000000000000000000000000000;
     parameter [31:0] ones=32'b11111111111111111111111111111111;
     parameter [31:0] high_z=32'bZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ;
     parameter [3:0] alu_nothing=4'b0000;
     parameter [3:0] alu_add=4'b0001;
     parameter [3:0] alu_subtract=4'b0010;
     parameter [3:0] alu_less_than=4'b0011;
     parameter [3:0] alu_less_than_signed=4'b0100;
     parameter [3:0] alu_or=4'b0101;
     parameter [3:0] alu_and=4'b0110;
     parameter [3:0] alu_xor=4'b0111;
     parameter [3:0] alu_nor=4'b1000;
     parameter [1:0] shift_nothing=2'b00;
     parameter [1:0] shift_left_unsigned=2'b01;
     parameter [1:0] shift_right_signed=2'b11;
     parameter [1:0] shift_right_unsigned=2'b10;
     parameter [3:0] mult_nothing=4'b0000;
     parameter [3:0] mult_read_lo=4'b0001;
     parameter [3:0] mult_read_hi=4'b0010;
     parameter [3:0] mult_write_lo=4'b0011;
     parameter [3:0] mult_write_hi=4'b0100;
     parameter [3:0] mult_mult=4'b0101;
     parameter [3:0] mult_signed_mult=4'b0110;
     parameter [3:0] mult_divide=4'b0111;
     parameter [3:0] mult_signed_divide=4'b1000;
     parameter [1:0] a_from_reg_source=2'b00;
     parameter [1:0] a_from_imm10_6=2'b01;
     parameter [1:0] a_from_pc=2'b10;
     parameter [1:0] b_from_reg_target=2'b00;
     parameter [1:0] b_from_imm=2'b01;
     parameter [1:0] b_from_signed_imm=2'b10;
     parameter [1:0] b_from_immx4=2'b11;
     parameter [2:0] c_from_null=3'b000;
     parameter [2:0] c_from_alu=3'b001;
     parameter [2:0] c_from_shift=3'b001;
     parameter [2:0] c_from_mult=3'b001;
     parameter [2:0] c_from_memory=3'b010;
     parameter [2:0] c_from_pc=3'b011;
     parameter [2:0] c_from_pc_plus4=3'b100;
     parameter [2:0] c_from_imm_shift16=3'b101;
     parameter [2:0] c_from_reg_sourcen=3'b110;
     parameter [1:0] from_inc4=2'b00;
     parameter [1:0] from_opcode25_0=2'b01;
     parameter [1:0] from_branch=2'b10;
     parameter [1:0] from_lbranch=2'b11;
     parameter [2:0] branch_ltz=3'b000;
     parameter [2:0] branch_lez=3'b001;
     parameter [2:0] branch_eq=3'b010;
     parameter [2:0] branch_ne=3'b011;
     parameter [2:0] branch_gez=3'b100;
     parameter [2:0] branch_gtz=3'b101;
     parameter [2:0] branch_yes=3'b110;
     parameter [3:0] mem_fetch=4'b0000;
     parameter [3:0] mem_read32=4'b0100;
     parameter [3:0] mem_write32=4'b0101;
     parameter [3:0] mem_read16=4'b1000;
     parameter [3:0] mem_read16s=4'b1010;
     parameter [3:0] mem_write16=4'b1001;
     parameter [3:0] mem_read8=4'b1100;
     parameter [3:0] mem_read8s=4'b1110;
     parameter [3:0] mem_write8=4'b1101;

    input clk_in;
    input reset_n;
    input uart_read;
    output uart_write;
    output [31:0]  address ;
    output [31:0]  data ;
    output we_n;
    output oe_n;
    output [3:0]  be_n ;
    output sram0_cs_n;
    output sram1_cs_n;


    reg clk_reg;
    wire reset_in;
    wire intr_in;
    wire [31:0] mem_address;
    wire mem_pause_in;
    wire write_enable;
    wire [3:0] mem_byte_sel;
    wire uart_write;
    wire [31:0] address;
    wire [31:0] data;
    wire we_n;
    wire oe_n;
    wire [3:0] be_n;
    wire sram0_cs_n;
    wire sram1_cs_n;


    
   assign {reset_in}=~ (reset_n);
   
   assign {intr_in}=1'b0;
   
   assign {mem_pause_in}=1'b0;
   
   assign {address}=mem_address;
   
   assign {we_n}=~ (write_enable);
   
   assign {oe_n}=write_enable;
   
   assign {be_n}=~ (mem_byte_sel);
   
   assign {sram0_cs_n}=~ (mem_address[16]);
   
   assign {sram1_cs_n}=~ (mem_address[16]);
   
   always @ (posedge clk_in or posedge reset_in ) begin
       if ((reset_in === 1'b1)) 
           clk_reg <= 1'b0;
           
       else 
           clk_reg <= ~ (clk_reg);
           
       
   end //always
       
   plasma  #(.memory_type(memory_type),.log_file(log_file)) u1_plama(.clk_in(clk_reg), .reset_in(reset_in), .intr_in(intr_in), .uart_read(uart_read), .uart_write(uart_write), .mem_address_out(mem_address), .mem_data(data), .mem_byte_sel_out(mem_byte_sel), .mem_write_out(write_enable), .mem_pause_in(mem_pause_in));
   //Parameter Order: memory_type,log_file 
    

endmodule
//-------------------------------------------------------------------
// TITLE: Plasma (CPU core with memory)
// AUTHOR: Steve Rhoads (rhoadss@yahoo.com)
// DATE CREATED: 6/4/02
// FILENAME: plasma.vhd
// PROJECT: Plasma CPU core
// COPYRIGHT: Software placed into the public domain by the author.
//    Software 'as is' without warranty.  Author liable for nothing.
// DESCRIPTION:
//    This entity combines the CPU core with memory and a UART.
//-------------------------------------------------------------------


module  plasma ( clk_in, reset_in, intr_in, uart_read, uart_write, mem_address_out, mem_data, mem_byte_sel_out, mem_write_out, mem_pause_in );
parameter memory_type="ALTERA";
parameter log_file="UNUSED";
         parameter [31:0] zero=32'b00000000000000000000000000000000;
     parameter [31:0] ones=32'b11111111111111111111111111111111;
     parameter [31:0] high_z=32'bZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ;
     parameter [3:0] alu_nothing=4'b0000;
     parameter [3:0] alu_add=4'b0001;
     parameter [3:0] alu_subtract=4'b0010;
     parameter [3:0] alu_less_than=4'b0011;
     parameter [3:0] alu_less_than_signed=4'b0100;
     parameter [3:0] alu_or=4'b0101;
     parameter [3:0] alu_and=4'b0110;
     parameter [3:0] alu_xor=4'b0111;
     parameter [3:0] alu_nor=4'b1000;
     parameter [1:0] shift_nothing=2'b00;
     parameter [1:0] shift_left_unsigned=2'b01;
     parameter [1:0] shift_right_signed=2'b11;
     parameter [1:0] shift_right_unsigned=2'b10;
     parameter [3:0] mult_nothing=4'b0000;
     parameter [3:0] mult_read_lo=4'b0001;
     parameter [3:0] mult_read_hi=4'b0010;
     parameter [3:0] mult_write_lo=4'b0011;
     parameter [3:0] mult_write_hi=4'b0100;
     parameter [3:0] mult_mult=4'b0101;
     parameter [3:0] mult_signed_mult=4'b0110;
     parameter [3:0] mult_divide=4'b0111;
     parameter [3:0] mult_signed_divide=4'b1000;
     parameter [1:0] a_from_reg_source=2'b00;
     parameter [1:0] a_from_imm10_6=2'b01;
     parameter [1:0] a_from_pc=2'b10;
     parameter [1:0] b_from_reg_target=2'b00;
     parameter [1:0] b_from_imm=2'b01;
     parameter [1:0] b_from_signed_imm=2'b10;
     parameter [1:0] b_from_immx4=2'b11;
     parameter [2:0] c_from_null=3'b000;
     parameter [2:0] c_from_alu=3'b001;
     parameter [2:0] c_from_shift=3'b001;
     parameter [2:0] c_from_mult=3'b001;
     parameter [2:0] c_from_memory=3'b010;
     parameter [2:0] c_from_pc=3'b011;
     parameter [2:0] c_from_pc_plus4=3'b100;
     parameter [2:0] c_from_imm_shift16=3'b101;
     parameter [2:0] c_from_reg_sourcen=3'b110;
     parameter [1:0] from_inc4=2'b00;
     parameter [1:0] from_opcode25_0=2'b01;
     parameter [1:0] from_branch=2'b10;
     parameter [1:0] from_lbranch=2'b11;
     parameter [2:0] branch_ltz=3'b000;
     parameter [2:0] branch_lez=3'b001;
     parameter [2:0] branch_eq=3'b010;
     parameter [2:0] branch_ne=3'b011;
     parameter [2:0] branch_gez=3'b100;
     parameter [2:0] branch_gtz=3'b101;
     parameter [2:0] branch_yes=3'b110;
     parameter [3:0] mem_fetch=4'b0000;
     parameter [3:0] mem_read32=4'b0100;
     parameter [3:0] mem_write32=4'b0101;
     parameter [3:0] mem_read16=4'b1000;
     parameter [3:0] mem_read16s=4'b1010;
     parameter [3:0] mem_write16=4'b1001;
     parameter [3:0] mem_read8=4'b1100;
     parameter [3:0] mem_read8s=4'b1110;
     parameter [3:0] mem_write8=4'b1101;

    input clk_in;
    input reset_in;
    input intr_in;
    input uart_read;
    output uart_write;
    output [31:0]  mem_address_out ;
    output [31:0]  mem_data ;
    output [3:0]  mem_byte_sel_out ;
    output mem_write_out;
    input mem_pause_in;


    wire [31:0] mem_address;
    wire [31:0] mem_data_r;
    wire [31:0] mem_data_w;
    wire [3:0] mem_byte_sel;
    wire mem_write;
    wire mem_pause;
    wire mem_pause_uart;
    wire uart_sel;
    wire uart_write;
    wire [31:0] mem_address_out;
    wire [31:0] mem_data;
    wire [3:0] mem_byte_sel_out;
    wire mem_write_out;


    
   assign {uart_sel}=((mem_address[12:0] === ones[12:0]) & (!(mem_byte_sel===4'b0000))) ? 
                         1'b1
                      :  1'b0;
   
   assign {mem_data}=mem_data_r;
   
   assign {mem_pause}=((mem_pause_in & ~ (uart_sel)) | mem_pause_uart);
   
   mlite_cpu  #(.memory_type(memory_type)/*open */ /* "GENERIC" */  /* "GENERIC" */ /*open */ /* 3 */ /*open */) u1_cpu(.clk(clk_in), .reset_in(reset_in), .intr_in(intr_in), .mem_address(mem_address), .mem_data_w(mem_data_w), .mem_data_r(mem_data_r), .mem_byte_sel(mem_byte_sel), .mem_write(mem_write), .mem_pause(mem_pause));
   //Parameter Order: memory_type,mult_type,shifter_type,pipeline_stages 

   ram  #(.memory_type(memory_type)) u2_ram(.clk(clk_in), .mem_byte_sel(mem_byte_sel), .mem_write(mem_write), .mem_address(mem_address), .mem_data_w(mem_data_w), .mem_data_r(mem_data_r));
   //Parameter Order: memory_type 

   uart  #(.log_file(log_file)) u3_uart(.clk(clk_in), .reset(reset_in), .uart_sel(uart_sel), .data(mem_data_w[7:0]), .uart_read(uart_read), .uart_write(uart_write), .pause(mem_pause_uart));
   //Parameter Order: log_file 

   assign {mem_address_out}=mem_address;
   
   assign {mem_byte_sel_out}=mem_byte_sel;
   
   assign {mem_write_out}=mem_write;
    

endmodule
//-------------------------------------------------------------------
// TITLE: Pipeline
// AUTHOR: Steve Rhoads (rhoadss@yahoo.com)
// DATE CREATED: 6/24/02
// FILENAME: pipeline.vhd
// PROJECT: Plasma CPU core
// COPYRIGHT: Software placed into the public domain by the author.
//    Software 'as is' without warranty.  Author liable for nothing.
// DESCRIPTION:
//    Controls the three stage pipeline by delaying the signals:
//      a_bus, b_bus, alu/shift/mult_func, c_source, and rs_index.
//-------------------------------------------------------------------


module  pipeline ( clk, reset, a_bus, a_busd, b_bus, b_busd, alu_func, alu_funcd, shift_func, shift_funcd, mult_func, mult_funcd, reg_dest, reg_destd, rd_index, rd_indexd, rs_index, rt_index, pc_source, mem_source, a_source, b_source, c_source, c_bus, pause_any, pause_pipeline );
         parameter [31:0] zero=32'b00000000000000000000000000000000;
     parameter [31:0] ones=32'b11111111111111111111111111111111;
     parameter [31:0] high_z=32'bZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ;
     parameter [3:0] alu_nothing=4'b0000;
     parameter [3:0] alu_add=4'b0001;
     parameter [3:0] alu_subtract=4'b0010;
     parameter [3:0] alu_less_than=4'b0011;
     parameter [3:0] alu_less_than_signed=4'b0100;
     parameter [3:0] alu_or=4'b0101;
     parameter [3:0] alu_and=4'b0110;
     parameter [3:0] alu_xor=4'b0111;
     parameter [3:0] alu_nor=4'b1000;
     parameter [1:0] shift_nothing=2'b00;
     parameter [1:0] shift_left_unsigned=2'b01;
     parameter [1:0] shift_right_signed=2'b11;
     parameter [1:0] shift_right_unsigned=2'b10;
     parameter [3:0] mult_nothing=4'b0000;
     parameter [3:0] mult_read_lo=4'b0001;
     parameter [3:0] mult_read_hi=4'b0010;
     parameter [3:0] mult_write_lo=4'b0011;
     parameter [3:0] mult_write_hi=4'b0100;
     parameter [3:0] mult_mult=4'b0101;
     parameter [3:0] mult_signed_mult=4'b0110;
     parameter [3:0] mult_divide=4'b0111;
     parameter [3:0] mult_signed_divide=4'b1000;
     parameter [1:0] a_from_reg_source=2'b00;
     parameter [1:0] a_from_imm10_6=2'b01;
     parameter [1:0] a_from_pc=2'b10;
     parameter [1:0] b_from_reg_target=2'b00;
     parameter [1:0] b_from_imm=2'b01;
     parameter [1:0] b_from_signed_imm=2'b10;
     parameter [1:0] b_from_immx4=2'b11;
     parameter [2:0] c_from_null=3'b000;
     parameter [2:0] c_from_alu=3'b001;
     parameter [2:0] c_from_shift=3'b001;
     parameter [2:0] c_from_mult=3'b001;
     parameter [2:0] c_from_memory=3'b010;
     parameter [2:0] c_from_pc=3'b011;
     parameter [2:0] c_from_pc_plus4=3'b100;
     parameter [2:0] c_from_imm_shift16=3'b101;
     parameter [2:0] c_from_reg_sourcen=3'b110;
     parameter [1:0] from_inc4=2'b00;
     parameter [1:0] from_opcode25_0=2'b01;
     parameter [1:0] from_branch=2'b10;
     parameter [1:0] from_lbranch=2'b11;
     parameter [2:0] branch_ltz=3'b000;
     parameter [2:0] branch_lez=3'b001;
     parameter [2:0] branch_eq=3'b010;
     parameter [2:0] branch_ne=3'b011;
     parameter [2:0] branch_gez=3'b100;
     parameter [2:0] branch_gtz=3'b101;
     parameter [2:0] branch_yes=3'b110;
     parameter [3:0] mem_fetch=4'b0000;
     parameter [3:0] mem_read32=4'b0100;
     parameter [3:0] mem_write32=4'b0101;
     parameter [3:0] mem_read16=4'b1000;
     parameter [3:0] mem_read16s=4'b1010;
     parameter [3:0] mem_write16=4'b1001;
     parameter [3:0] mem_read8=4'b1100;
     parameter [3:0] mem_read8s=4'b1110;
     parameter [3:0] mem_write8=4'b1101;

    input clk;
    input reset;
    input [31:0]  a_bus ;
    output [31:0]  a_busd ;
    input [31:0]  b_bus ;
    output [31:0]  b_busd ;
    input [3:0]  alu_func ;
    output [3:0]  alu_funcd ;
    input [1:0]  shift_func ;
    output [1:0]  shift_funcd ;
    input [3:0]  mult_func ;
    output [3:0]  mult_funcd ;
    input [31:0]  reg_dest ;
    output [31:0]  reg_destd ;
    input [5:0]  rd_index ;
    output [5:0]  rd_indexd ;
    input [5:0]  rs_index ;
    input [5:0]  rt_index ;
    input [1:0]  pc_source ;
    input [3:0]  mem_source ;
    input [1:0]  a_source ;
    input [1:0]  b_source ;
    input [2:0]  c_source ;
    input [31:0]  c_bus ;
    input pause_any;
    output pause_pipeline;


    reg pipeline3__pause_mult_clock;
    reg pipeline3__freeze_pipeline;
    reg [5:0] rd_index_reg;
    reg [31:0] reg_dest_reg;
    reg [31:0] reg_dest_delay;
    reg [2:0] c_source_reg;
    reg pause_enable_reg;
    reg [31:0] a_busd;
    reg [31:0] b_busd;
    reg [3:0] alu_funcd;
    reg [1:0] shift_funcd;
    reg [3:0] mult_funcd;
    reg [31:0] reg_destd;
    reg [5:0] rd_indexd;
    reg pause_pipeline;


    
   always @ (posedge clk or posedge reset ) begin
       if ((reset === 1'b1)) 
           begin 
               pause_enable_reg <= 1'b1;
               rd_index_reg <= 6'b000000;
           end
           
       else 
           begin 
               begin 
                   if ((pipeline3__freeze_pipeline === 1'b0)) 
                       begin 
                           begin 
                               if ((((rs_index === 6'b000000) | (!(rs_index===rd_index_reg))) | ((!(a_source===a_from_reg_source)) | (pause_enable_reg === 1'b0)))) 
                                       a_busd <= a_bus;
                               else 
                                       a_busd <= reg_dest_delay;

                               if ((((rt_index === 6'b000000) | (!(rt_index===rd_index_reg))) | ((!(b_source===b_from_reg_target)) | (pause_enable_reg === 1'b0)))) 
                                       b_busd <= b_bus;
                               else 
                                       b_busd <= reg_dest_delay;

                               alu_funcd <= alu_func;
                               shift_funcd <= shift_func;
                               mult_funcd <= mult_func;
                               reg_dest_reg <= reg_dest;
                               c_source_reg <= c_source;
                               rd_index_reg <= rd_index;
                           end
                       end 
                   
                   if (((pause_enable_reg === 1'b0) & (pause_any === 1'b0))) 
                       pause_enable_reg <= 1'b1;
                       
                   else if ((pipeline3__pause_mult_clock === 1'b1)) 
                       pause_enable_reg <= 1'b0;
                       
                   
                   
               end
               
           end 
       
   end //always
       
   always @ (clk or reset or a_bus or b_bus or alu_func or shift_func or mult_func or rd_index or rd_index_reg or pause_any or pause_enable_reg or rs_index or rt_index or pc_source or mem_source or a_source or b_source or c_source or c_source_reg or reg_dest or reg_dest_reg or reg_dest_delay or c_bus ) begin
       begin 
           if (((((!(pc_source===from_inc4)) & (!(pc_source===from_opcode25_0))) | (!(mem_source===mem_fetch))) | ((mult_func === mult_read_lo) | (mult_func === mult_read_hi)))) 
               pipeline3__pause_mult_clock = 1'b1;
               
           else 
               pipeline3__pause_mult_clock = 1'b0;
               
           pipeline3__freeze_pipeline = (~ ((pipeline3__pause_mult_clock & pause_enable_reg)) & pause_any);
           pause_pipeline <= (pipeline3__pause_mult_clock & pause_enable_reg);
           rd_indexd <= rd_index_reg;
           if ((c_source_reg === c_from_alu)) 
               reg_dest_delay <= c_bus;
               
           else 
               reg_dest_delay <= reg_dest_reg;
               
           reg_destd <= reg_dest_delay;
           
       end 
   end //always
    

endmodule
//-------------------------------------------------------------------
// TITLE: Program Counter Next
// AUTHOR: Steve Rhoads (rhoadss@yahoo.com)
// DATE CREATED: 2/8/01
// FILENAME: pc_next.vhd
// PROJECT: Plasma CPU core
// COPYRIGHT: Software placed into the public domain by the author.
//    Software 'as is' without warranty.  Author liable for nothing.
// DESCRIPTION:
//    Implements the Program Counter logic.
//-------------------------------------------------------------------


module  pc_next ( clk, reset_in, pc_new, take_branch, pause_in, opcode25_0, pc_source, pc_out, pc_out_plus4 );
         parameter [31:0] zero=32'b00000000000000000000000000000000;
     parameter [31:0] ones=32'b11111111111111111111111111111111;
     parameter [31:0] high_z=32'bZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ;
     parameter [3:0] alu_nothing=4'b0000;
     parameter [3:0] alu_add=4'b0001;
     parameter [3:0] alu_subtract=4'b0010;
     parameter [3:0] alu_less_than=4'b0011;
     parameter [3:0] alu_less_than_signed=4'b0100;
     parameter [3:0] alu_or=4'b0101;
     parameter [3:0] alu_and=4'b0110;
     parameter [3:0] alu_xor=4'b0111;
     parameter [3:0] alu_nor=4'b1000;
     parameter [1:0] shift_nothing=2'b00;
     parameter [1:0] shift_left_unsigned=2'b01;
     parameter [1:0] shift_right_signed=2'b11;
     parameter [1:0] shift_right_unsigned=2'b10;
     parameter [3:0] mult_nothing=4'b0000;
     parameter [3:0] mult_read_lo=4'b0001;
     parameter [3:0] mult_read_hi=4'b0010;
     parameter [3:0] mult_write_lo=4'b0011;
     parameter [3:0] mult_write_hi=4'b0100;
     parameter [3:0] mult_mult=4'b0101;
     parameter [3:0] mult_signed_mult=4'b0110;
     parameter [3:0] mult_divide=4'b0111;
     parameter [3:0] mult_signed_divide=4'b1000;
     parameter [1:0] a_from_reg_source=2'b00;
     parameter [1:0] a_from_imm10_6=2'b01;
     parameter [1:0] a_from_pc=2'b10;
     parameter [1:0] b_from_reg_target=2'b00;
     parameter [1:0] b_from_imm=2'b01;
     parameter [1:0] b_from_signed_imm=2'b10;
     parameter [1:0] b_from_immx4=2'b11;
     parameter [2:0] c_from_null=3'b000;
     parameter [2:0] c_from_alu=3'b001;
     parameter [2:0] c_from_shift=3'b001;
     parameter [2:0] c_from_mult=3'b001;
     parameter [2:0] c_from_memory=3'b010;
     parameter [2:0] c_from_pc=3'b011;
     parameter [2:0] c_from_pc_plus4=3'b100;
     parameter [2:0] c_from_imm_shift16=3'b101;
     parameter [2:0] c_from_reg_sourcen=3'b110;
     parameter [1:0] from_inc4=2'b00;
     parameter [1:0] from_opcode25_0=2'b01;
     parameter [1:0] from_branch=2'b10;
     parameter [1:0] from_lbranch=2'b11;
     parameter [2:0] branch_ltz=3'b000;
     parameter [2:0] branch_lez=3'b001;
     parameter [2:0] branch_eq=3'b010;
     parameter [2:0] branch_ne=3'b011;
     parameter [2:0] branch_gez=3'b100;
     parameter [2:0] branch_gtz=3'b101;
     parameter [2:0] branch_yes=3'b110;
     parameter [3:0] mem_fetch=4'b0000;
     parameter [3:0] mem_read32=4'b0100;
     parameter [3:0] mem_write32=4'b0101;
     parameter [3:0] mem_read16=4'b1000;
     parameter [3:0] mem_read16s=4'b1010;
     parameter [3:0] mem_write16=4'b1001;
     parameter [3:0] mem_read8=4'b1100;
     parameter [3:0] mem_read8s=4'b1110;
     parameter [3:0] mem_write8=4'b1101;

    input clk;
    input reset_in;
    input [31:2]  pc_new ;
    input take_branch;
    input pause_in;
    input [25:0]  opcode25_0 ;
    input [1:0]  pc_source ;
    output [31:0]  pc_out ;
    output [31:0]  pc_out_plus4 ;


    reg [31:2] pc_next__pc_inc;
    reg [31:2] pc_next__pc_next;
    reg [31:2] pc_reg;
    reg [31:0] pc_out;
    reg [31:0] pc_out_plus4;


    
   always @ (posedge clk or posedge reset_in ) begin
       if ((reset_in === 1'b1)) 
           pc_reg <= zero[31:2];
           
       else 
           pc_reg <= pc_next__pc_next;
           
       
   end //always
       
   always @ (clk or reset_in or pc_new or take_branch or pause_in or opcode25_0 or pc_source or pc_reg ) begin
       begin 
           pc_next__pc_inc = bv_increment__0(pc_reg);
           case (pc_source)
               2'b00 : 
                       pc_next__pc_next = pc_next__pc_inc;
               2'b01 : 
                       pc_next__pc_next = {pc_reg[31:28],opcode25_0};
               default : 
                       if ((take_branch === 1'b1)) 
                               pc_next__pc_next = pc_new;
                       else 
                               pc_next__pc_next = pc_next__pc_inc;

                       
           endcase
           if ((pause_in === 1'b1)) 
               pc_next__pc_next = pc_reg;
               
           pc_out <= {pc_reg,2'b00};
           pc_out_plus4 <= {pc_next__pc_inc,2'b00};
       end 
   end //always
    
    function [31:2] bv_increment__0;
        input [31:2]  a ;
        reg carry_in;
        reg [31:2] result;
        begin : Function
            begin 
                result = zero[31:2];
                carry_in = 1'b1;
                begin :Block_Name_1
                    integer index;
                    for (index=2;index<=31;index=index+1) begin 
                        begin 
                            result[index] = (a[index] ^ carry_in);
                            carry_in = (a[index] & carry_in);
                        end
                        
                    end //for
                end //end Block
                begin 
                    bv_increment__0=result;
                    disable Function;
                end
            end
        end // Function
    endfunction
        

    

endmodule
//-------------------------------------------------------------------
// TITLE: Multiplication and Division Unit
// AUTHORS: Steve Rhoads (rhoadss@yahoo.com)
//          Matthias Gruenewald
// DATE CREATED: 1/31/01
// FILENAME: mult.vhd
// PROJECT: Plasma CPU core
// COPYRIGHT: Software placed into the public domain by the author.
//    Software 'as is' without warranty.  Author liable for nothing.
// DESCRIPTION:
//    Implements the multiplication and division unit.
//    Division takes 32 clock cycles.
//    Multiplication normally takes 16 clock cycles.
//    if b <= 0xffff then mult in 8 cycles. 
//    if b <= 0xff then mult in 4 cycles. 
//
// For multiplication set reg_b = 0x00000000 & b.  The 64-bit result
// will be in reg_b.  The lower bits of reg_b contain the upper 
// bits of b that have not yet been multiplied.  For 16 clock cycles
// shift reg_b two bits to the right.  Use the lowest two bits of reg_b 
// to multiply by two bits at a time and add the result to the upper
// 32-bits of reg_b (using C syntax):
//    reg_b = (reg_b >> 2) + (((reg_b & 3) * reg_a) << 32);
//
// For division set reg_b = '0' & b & 30_ZEROS.  The answer will be
// in answer_reg and the remainder in reg_a.  For 32 clock cycles
// (using C syntax):
//    answer_reg = (answer_reg << 1);
//    if (reg_a >= reg_b) {
//       answer_reg += 1;
//       reg_a -= reg_b;
//    }
//    reg_b = reg_b >> 1;
//-------------------------------------------------------------------
//library ieee, MLITE_LIB;
//use MLITE_LIB.all;


module  mult ( clk, a, b, mult_func, c_mult, pause_out );
parameter adder_type="GENERIC";
parameter mult_type="GENERIC";
         parameter [31:0] zero=32'b00000000000000000000000000000000;
     parameter [31:0] ones=32'b11111111111111111111111111111111;
     parameter [31:0] high_z=32'bZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ;
     parameter [3:0] alu_nothing=4'b0000;
     parameter [3:0] alu_add=4'b0001;
     parameter [3:0] alu_subtract=4'b0010;
     parameter [3:0] alu_less_than=4'b0011;
     parameter [3:0] alu_less_than_signed=4'b0100;
     parameter [3:0] alu_or=4'b0101;
     parameter [3:0] alu_and=4'b0110;
     parameter [3:0] alu_xor=4'b0111;
     parameter [3:0] alu_nor=4'b1000;
     parameter [1:0] shift_nothing=2'b00;
     parameter [1:0] shift_left_unsigned=2'b01;
     parameter [1:0] shift_right_signed=2'b11;
     parameter [1:0] shift_right_unsigned=2'b10;
     parameter [3:0] mult_nothing=4'b0000;
     parameter [3:0] mult_read_lo=4'b0001;
     parameter [3:0] mult_read_hi=4'b0010;
     parameter [3:0] mult_write_lo=4'b0011;
     parameter [3:0] mult_write_hi=4'b0100;
     parameter [3:0] mult_mult=4'b0101;
     parameter [3:0] mult_signed_mult=4'b0110;
     parameter [3:0] mult_divide=4'b0111;
     parameter [3:0] mult_signed_divide=4'b1000;
     parameter [1:0] a_from_reg_source=2'b00;
     parameter [1:0] a_from_imm10_6=2'b01;
     parameter [1:0] a_from_pc=2'b10;
     parameter [1:0] b_from_reg_target=2'b00;
     parameter [1:0] b_from_imm=2'b01;
     parameter [1:0] b_from_signed_imm=2'b10;
     parameter [1:0] b_from_immx4=2'b11;
     parameter [2:0] c_from_null=3'b000;
     parameter [2:0] c_from_alu=3'b001;
     parameter [2:0] c_from_shift=3'b001;
     parameter [2:0] c_from_mult=3'b001;
     parameter [2:0] c_from_memory=3'b010;
     parameter [2:0] c_from_pc=3'b011;
     parameter [2:0] c_from_pc_plus4=3'b100;
     parameter [2:0] c_from_imm_shift16=3'b101;
     parameter [2:0] c_from_reg_sourcen=3'b110;
     parameter [1:0] from_inc4=2'b00;
     parameter [1:0] from_opcode25_0=2'b01;
     parameter [1:0] from_branch=2'b10;
     parameter [1:0] from_lbranch=2'b11;
     parameter [2:0] branch_ltz=3'b000;
     parameter [2:0] branch_lez=3'b001;
     parameter [2:0] branch_eq=3'b010;
     parameter [2:0] branch_ne=3'b011;
     parameter [2:0] branch_gez=3'b100;
     parameter [2:0] branch_gtz=3'b101;
     parameter [2:0] branch_yes=3'b110;
     parameter [3:0] mem_fetch=4'b0000;
     parameter [3:0] mem_read32=4'b0100;
     parameter [3:0] mem_write32=4'b0101;
     parameter [3:0] mem_read16=4'b1000;
     parameter [3:0] mem_read16s=4'b1010;
     parameter [3:0] mem_write16=4'b1001;
     parameter [3:0] mem_read8=4'b1100;
     parameter [3:0] mem_read8s=4'b1110;
     parameter [3:0] mem_write8=4'b1101;

    input clk;
    input [31:0]  a ;
    input [31:0]  b ;
    input [3:0]  mult_func ;
    output [31:0]  c_mult ;
    output pause_out;


    reg do_mult_reg;
    reg do_signed_reg;
    reg [5:0] count_reg;
    reg [31:0] reg_a;
    reg [63:0] reg_b;
    reg [31:0] answer_reg;
    reg /* conflict */[33:0] aa_=34'bz;
    wire /* conflict */[33:0] aa;
    reg /* conflict */[33:0] bb_=34'bz;
    wire /* conflict */[33:0] bb;
    wire [33:0] sum;
    wire [67:0] sum2;
    reg [33:0] reg_a_times3;
    reg /* conflict */sign_extend_sig_=1'bz;
    wire /* conflict */sign_extend_sig;
    wire [31:0] sub_y;
    wire [31:0] a_processed;
    wire [31:0] b_processed;
    wire [31:0] a_reg;
    wire [31:0] b_reg;
    reg [63:0] div_y = {(63-0+1- 0){1'b0}};
    reg [63:0] div_y_in = {(63-0+1- 0){1'b0}};
    reg [63:0] div_y_in_calc = {(63-0+1- 0){1'b0}};
    reg [63:0] div_y_in_init = {(63-0+1- 0){1'b0}};
    reg [63:0] y_in = {(63-0+1- 0){1'b0}};
    reg [63:0] y_in2 = {(63-0+1- 0){1'b0}};
    reg [63:0] mult_y = {(63-0+1- 0){1'b0}};
    reg [63:0] y = {(63-0+1- 0){1'b0}};
    wire save_y;
    wire save_div_y;
    wire mult_nd;
    wire mult_rdy;
    wire do_signed;
    wire div_nd;
    wire div_count;
    wire invert_a;
    wire invert_b;
    wire invert_y;
    wire div_rdy;
    wire [4:0] div_counter;
    reg pause_in;
   initial pause_in = 1'b0;
    reg save_pause;
   initial save_pause = 1'b0;
    reg pause;
   initial pause = 1'b0;
    wire mult_rfd;
    wire [31:0] a_temp_sig;
    wire [31:0] a_neg_sig;
    wire [31:0] b_neg_sig;
    wire [63:0] b_temp_sig;
    wire a_msb;
    wire b_msb;
    wire [31:0] answer_temp_sig;
    reg [3:0] aa_select;
    reg [1:0] bb_select;
    reg [4:0] a_select;
    reg [11:0] b_select;
    reg [2:0] answer_select;
    wire [31:0] c_mult;
    reg pause_out;


       
   
   generate
       if ((adder_type === "GENERIC"))begin//generate if 
               
           assign {sum}=(do_mult_reg === 1'b1) ? 
                            (aa + bb)
                         :  (aa - bb);
           
       end//generate if
   endgenerate
   
   
   generate
       if ((adder_type === "ALTERA"))begin//generate if 
               
           lpm_add_sub  #(.lpm_width(34),.lpm_direction("UNUSED"),.lpm_type("LPM_ADD_SUB"),.lpm_hint("ONE_INPUT_IS_CONSTANT=NO")) lpm_add_sub_component(.dataa(aa), .add_sub(do_mult_reg), .datab(bb), .result(sum));
           //Parameter Order: lpm_width,lpm_direction,lpm_type,lpm_hint 
       end//generate if
   endgenerate
   
   assign {a_neg_sig}=bv_negate__0(a);
   
   assign {b_neg_sig}=bv_negate__0(b);
   
   assign {sign_extend_sig}=(do_signed_reg & do_mult_reg);
   
   assign {c_mult}=(mult_func === mult_read_lo) ? 
                       reg_b[31:0]
                    : (mult_func === mult_read_hi) ? 
                       reg_b[63:32]
                    :  32'b00000000000000000000000000000000;
   
   
   generate
       if ((mult_type === "GENERIC"))begin//generate if 
                   reg mult_proc__do_mult_temp;
    reg mult_proc__do_signed_temp;
    reg [5:0] mult_proc__count_temp;
    reg [31:0] mult_proc__a_temp;
    reg [63:0] mult_proc__b_temp;
    reg [31:0] mult_proc__answer_temp;
    reg mult_proc__start;
    reg mult_proc__do_write;
    reg mult_proc__do_hi;
    reg mult_proc__sign_extend;
               
           always @ (posedge clk ) begin
                   begin 
                       do_mult_reg <= mult_proc__do_mult_temp;
                       do_signed_reg <= mult_proc__do_signed_temp;
                       count_reg <= mult_proc__count_temp;
                       reg_a <= mult_proc__a_temp;
                       reg_b <= mult_proc__b_temp;
                       answer_reg <= mult_proc__answer_temp;
                       if ((mult_proc__start === 1'b1)) 
                           reg_a_times3 <= ({{(mult_proc__a_temp[31] & mult_proc__do_signed_temp),mult_proc__a_temp},1'b0} + {{(mult_proc__a_temp[31] & mult_proc__do_signed_temp),(mult_proc__a_temp[31] & mult_proc__do_signed_temp)},mult_proc__a_temp});
                           
                       
                       
                   end
                   
               
           end //always
               
           always @ (clk or a or b or mult_func or do_mult_reg or do_signed_reg or count_reg or reg_a or reg_b or answer_reg or sum or reg_a_times3 ) begin
               begin 
                   mult_proc__do_mult_temp = do_mult_reg;
                   mult_proc__do_signed_temp = do_signed_reg;
                   mult_proc__count_temp = count_reg;
                   mult_proc__a_temp = reg_a;
                   mult_proc__b_temp = reg_b;
                   mult_proc__answer_temp = answer_reg;
                   mult_proc__sign_extend = (do_signed_reg & do_mult_reg);
                   mult_proc__start = 1'b0;
                   mult_proc__do_write = 1'b0;
                   mult_proc__do_hi = 1'b0;
                   case (mult_func)
                       4'b0001: ;
                       4'b0010 : 
                               mult_proc__do_hi = 1'b1;
                       4'b0011 : 
                               mult_proc__do_write = 1'b1;
                       4'b0100 : 
                           begin 
                               mult_proc__do_write = 1'b1;
                               mult_proc__do_hi = 1'b1;
                           end
                       4'b0101 : 
                           begin 
                               mult_proc__start = 1'b1;
                               mult_proc__do_mult_temp = 1'b1;
                               mult_proc__do_signed_temp = 1'b0;
                           end
                       4'b0110 : 
                           begin 
                               mult_proc__start = 1'b1;
                               mult_proc__do_mult_temp = 1'b1;
                               mult_proc__do_signed_temp = 1'b1;
                           end
                       4'b0111 : 
                           begin 
                               mult_proc__start = 1'b1;
                               mult_proc__do_mult_temp = 1'b0;
                               mult_proc__do_signed_temp = 1'b0;
                           end
                       4'b1000 : 
                           begin 
                               mult_proc__start = 1'b1;
                               mult_proc__do_mult_temp = 1'b0;
                               mult_proc__do_signed_temp = (a[31] ^ b[31]);
                           end
                       default : 
                           ;
                   endcase
                   if ((mult_proc__start === 1'b1)) 
                       begin 
                           mult_proc__count_temp = 6'b000000;
                           mult_proc__answer_temp = 32'b00000000000000000000000000000000;
                           if ((mult_proc__do_mult_temp === 1'b0)) 
                               begin 
                                   mult_proc__b_temp[63] = 1'b0;
                                   if (((!(mult_func===mult_signed_divide)) | (a[31] === 1'b0))) 
                                       mult_proc__a_temp = a;
                                       
                                   else 
                                       mult_proc__a_temp = a_neg_sig;
                                       
                                   
                                   if (((!(mult_func===mult_signed_divide)) | (b[31] === 1'b0))) 
                                       mult_proc__b_temp[62:31] = b;
                                       
                                   else 
                                       mult_proc__b_temp[62:31] = b_neg_sig;
                                       
                                   
                                   mult_proc__b_temp[30:0] = zero[30:0];
                               end
                               
                           else 
                               begin 
                                   begin 
                                       if (((mult_proc__do_signed_temp === 1'b0) | (b[31] === 1'b0))) 
                                           begin 
                                               mult_proc__a_temp = a;
                                               mult_proc__b_temp[31:0] = b;
                                           end
                                       else 
                                           begin 
                                               mult_proc__a_temp = a_neg_sig;
                                               mult_proc__b_temp[31:0] = b_neg_sig;
                                           end

                                       mult_proc__b_temp[63:32] = 32'b00000000000000000000000000000000;
                                   end
                               end 
                           
                           
                       end
                       
                   else if ((mult_proc__do_write === 1'b1)) 
                       begin 
                           if ((mult_proc__do_hi === 1'b0)) 
                               mult_proc__b_temp[31:0] = a;
                               
                           else 
                               mult_proc__b_temp[63:32] = a;
                               
                           
                           
                       end 
                   if ((do_mult_reg === 1'b0)) 
                       begin 
                           aa_ <= {{(reg_a[31] & mult_proc__sign_extend),(reg_a[31] & mult_proc__sign_extend)},reg_a};
                           bb_ <= reg_b[33:0];
                       end
                       
                   else 
                       begin 
                           case (reg_b[1:0])
                               2'b00 : 
                                       aa_ <= {1'b0, 1'b0, 1'b0, 1'b0, 1'b0, 1'b0, 1'b0, 1'b0, 1'b0, 1'b0, 1'b0, 1'b0, 1'b0, 1'b0, 1'b0, 1'b0, 1'b0, 1'b0, 1'b0, 1'b0, 1'b0, 1'b0, 1'b0, 1'b0, 1'b0, 1'b0, 1'b0, 1'b0, 1'b0, 1'b0, 1'b0, 1'b0, 1'b0, 1'b0/*aggregate*/};
                               2'b01 : 
                                       aa_ <= {{(reg_a[31] & mult_proc__sign_extend),(reg_a[31] & mult_proc__sign_extend)},reg_a};
                               2'b10 : 
                                       aa_ <= {{(reg_a[31] & mult_proc__sign_extend),reg_a},1'b0};
                               default : 
                                       aa_ <= reg_a_times3;
                           endcase
                           bb_ <= {{(reg_b[63] & mult_proc__sign_extend),(reg_b[63] & mult_proc__sign_extend)},reg_b[63:32]};
                       end
                       
                   if (((count_reg[5] === 1'b0) & (mult_proc__start === 1'b0))) 
                       begin 
                           mult_proc__count_temp = bv_inc6__1(count_reg);
                           if ((do_mult_reg === 1'b0)) 
                               begin 
                                   mult_proc__answer_temp[31:1] = answer_reg[30:0];
                                   if (((reg_b[63:32] === zero) & (sum[32] === 1'b0))) 
                                       begin 
                                           mult_proc__a_temp = sum[31:0];
                                           mult_proc__answer_temp[0] = 1'b1;
                                       end
                                       
                                   else 
                                       mult_proc__answer_temp[0] = 1'b0;
                                       
                                   
                                   if ((!(count_reg===6'b011111))) 
                                       mult_proc__b_temp[62:0] = reg_b[63:1];
                                       
                                   else 
                                       begin 
                                           mult_proc__b_temp[63:32] = mult_proc__a_temp;
                                           if ((do_signed_reg === 1'b0)) 
                                               mult_proc__b_temp[31:0] = mult_proc__answer_temp;
                                               
                                           else 
                                               mult_proc__b_temp[31:0] = bv_negate__0(mult_proc__answer_temp);
                                               
                                           
                                           
                                       end
                                       
                                   
                                   
                               end
                               
                           else 
                               begin 
                                   mult_proc__b_temp[63:30] = sum;
                                   mult_proc__b_temp[29:0] = reg_b[31:2];
                                   if ((((count_reg === 6'b001000) & (mult_proc__sign_extend === 1'b0)) & (reg_b[15:0] === zero[15:0]))) 
                                       begin 
                                           mult_proc__count_temp = 6'b111111;
                                           mult_proc__b_temp[31:0] = reg_b[47:16];
                                       end
                                       
                                   
                                   if ((((count_reg === 6'b000100) & (mult_proc__sign_extend === 1'b0)) & (reg_b[23:0] === zero[23:0]))) 
                                       begin 
                                           mult_proc__count_temp = 6'b111111;
                                           mult_proc__b_temp[31:0] = reg_b[55:24];
                                       end
                                       
                                   
                                   mult_proc__count_temp[5] = mult_proc__count_temp[4];
                               end
                               
                           
                           
                       end
                       
                   if ((((count_reg[5] === 1'b0) & (!(mult_func===mult_nothing))) & (mult_proc__start === 1'b0))) 
                       pause_out <= 1'b1;
                       
                   else 
                       pause_out <= 1'b0;
                       
                   
               end 
           end //always
           
       end//generate if
   endgenerate
   
   
   generate
       if ((mult_type === "AREA_OPTIMIZED"))begin//generate if 
                   reg mult_proc__do_mult_temp;
    reg mult_proc__do_signed_temp;
    reg [5:0] mult_proc__count_temp;
    reg mult_proc__start;
    reg mult_proc__do_write;
    reg mult_proc__do_hi;
    reg mult_proc__sign_extend;
               
           always @ (posedge clk ) begin
                   begin 
                       do_mult_reg <= mult_proc__do_mult_temp;
                       do_signed_reg <= mult_proc__do_signed_temp;
                       count_reg <= mult_proc__count_temp;
                       reg_a <= a_temp_sig;
                       reg_b <= b_temp_sig;
                       answer_reg <= answer_temp_sig;
                       if ((mult_proc__start === 1'b1)) 
                           reg_a_times3 <= ({{(a_temp_sig[31] & mult_proc__do_signed_temp),a_temp_sig},1'b0} + {{(a_temp_sig[31] & mult_proc__do_signed_temp),(a_temp_sig[31] & mult_proc__do_signed_temp)},a_temp_sig});
                           
                       
                       
                   end
                   
               
           end //always
               
           always @ (a or b or clk or count_reg or do_mult_reg or do_signed_reg or mult_func or reg_b or sum ) begin
               begin 
                   mult_proc__do_mult_temp = do_mult_reg;
                   mult_proc__do_signed_temp = do_signed_reg;
                   mult_proc__count_temp = count_reg;
                   mult_proc__sign_extend = (do_signed_reg & do_mult_reg);
                   sign_extend_sig_ <= mult_proc__sign_extend;
                   mult_proc__start = 1'b0;
                   mult_proc__do_write = 1'b0;
                   mult_proc__do_hi = 1'b0;
                   a_select <= {(4-0+1- 0){1'b0}};
                   b_select <= {(11-0+1- 0){1'b0}};
                   aa_select <= {(3-0+1- 0){1'b0}};
                   bb_select <= {(1-0+1- 0){1'b0}};
                   answer_select <= {(2-0+1- 0){1'b0}};
                   case (mult_func)
                       4'b0001: ;
                       4'b0010 : 
                               mult_proc__do_hi = 1'b1;
                       4'b0011 : 
                               mult_proc__do_write = 1'b1;
                       4'b0100 : 
                           begin 
                               mult_proc__do_write = 1'b1;
                               mult_proc__do_hi = 1'b1;
                           end
                       4'b0101 : 
                           begin 
                               mult_proc__start = 1'b1;
                               mult_proc__do_mult_temp = 1'b1;
                               mult_proc__do_signed_temp = 1'b0;
                           end
                       4'b0110 : 
                           begin 
                               mult_proc__start = 1'b1;
                               mult_proc__do_mult_temp = 1'b1;
                               mult_proc__do_signed_temp = 1'b1;
                           end
                       4'b0111 : 
                           begin 
                               mult_proc__start = 1'b1;
                               mult_proc__do_mult_temp = 1'b0;
                               mult_proc__do_signed_temp = 1'b0;
                           end
                       4'b1000 : 
                           begin 
                               mult_proc__start = 1'b1;
                               mult_proc__do_mult_temp = 1'b0;
                               mult_proc__do_signed_temp = (a[31] ^ b[31]);
                           end
                       default : 
                           ;
                   endcase
                   if ((mult_proc__start === 1'b1)) 
                       begin 
                           mult_proc__count_temp = 6'b000000;
                           answer_select[0] <= 1'b1;
                           if ((mult_proc__do_mult_temp === 1'b0)) 
                               begin 
                                   begin 
                                       if (((!(mult_func===mult_signed_divide)) | (a[31] === 1'b0))) 
                                               a_select[0] <= 1'b1;
                                       else 
                                               a_select[1] <= 1'b1;

                                       if (((!(mult_func===mult_signed_divide)) | (b[31] === 1'b0))) 
                                               b_select[0] <= 1'b1;
                                       else 
                                               b_select[1] <= 1'b1;

                                       
                                   end
                               end 
                           else 
                               begin 
                                       if (((mult_proc__do_signed_temp === 1'b0) | (b[31] === 1'b0))) 
                                           begin 
                                               a_select[2] <= 1'b1;
                                               b_select[2] <= 1'b1;
                                           end
                                       else 
                                           begin 
                                               a_select[3] <= 1'b1;
                                               b_select[3] <= 1'b1;
                                           end

                                       
                               end 
                           
                           
                       end
                       
                   else if ((mult_proc__do_write === 1'b1)) 
                       begin 
                           if ((mult_proc__do_hi === 1'b0)) 
                               b_select[4] <= 1'b1;
                               
                           else 
                               b_select[5] <= 1'b1;
                               
                           
                           
                       end 
                   if ((do_mult_reg === 1'b0)) 
                       begin 
                           aa_select[0] <= 1'b1;
                           bb_select[0] <= 1'b1;
                       end
                       
                   else 
                       begin 
                           case (reg_b[1:0])
                               2'b00 : 
                                       aa_select[1] <= 1'b1;
                               2'b01 : 
                                       aa_select[2] <= 1'b1;
                               2'b10 : 
                                       aa_select[3] <= 1'b1;
                               default : 
                                   ;
                           endcase
                           bb_select[1] <= 1'b1;
                       end
                       
                   if (((count_reg[5] === 1'b0) & (mult_proc__start === 1'b0))) 
                       begin 
                           mult_proc__count_temp = bv_inc6__1(count_reg);
                           if ((do_mult_reg === 1'b0)) 
                               begin 
                                   begin 
                                       if (((reg_b[63:32] === zero) & (sum[32] === 1'b0))) 
                                           begin 
                                               a_select[4] <= 1'b1;
                                               answer_select[1] <= 1'b1;
                                           end
                                       else 
                                               answer_select[2] <= 1'b1;

                                       if ((!(count_reg===6'b011111))) 
                                               b_select[6] <= 1'b1;
                                       else 
                                           begin 
                                                   if ((do_signed_reg === 1'b0)) 
                                                           b_select[7] <= 1'b1;
                                                   else 
                                                           b_select[8] <= 1'b1;

                                                   
                                           end 

                                       
                                   end
                               end 
                           else 
                               begin 
                                   b_select[9] <= 1'b1;
                                   if ((((count_reg === 6'b001000) & (mult_proc__sign_extend === 1'b0)) & (reg_b[15:0] === zero[15:0]))) 
                                       begin 
                                           mult_proc__count_temp = 6'b111111;
                                           b_select[10] <= 1'b1;
                                       end
                                       
                                   
                                   if ((((count_reg === 6'b000100) & (mult_proc__sign_extend === 1'b0)) & (reg_b[23:0] === zero[23:0]))) 
                                       begin 
                                           mult_proc__count_temp = 6'b111111;
                                           b_select[11] <= 1'b1;
                                       end
                                       
                                   
                                   mult_proc__count_temp[5] = mult_proc__count_temp[4];
                               end
                               
                           
                           
                       end
                       
                   if ((((count_reg[5] === 1'b0) & (!(mult_func===mult_nothing))) & (mult_proc__start === 1'b0))) 
                       pause_out <= 1'b1;
                       
                   else 
                       pause_out <= 1'b0;
                       
                   
               end 
           end //always
           
           assign {a_msb}=(reg_a[31] & sign_extend_sig);
           
           assign {aa}=(aa_select[0] === 1'b1) ? 
                           {{a_msb,a_msb},reg_a}
                        : (aa_select[1] === 1'b1) ? 
                           {1'b0, 1'b0, 1'b0, 1'b0, 1'b0, 1'b0, 1'b0, 1'b0, 1'b0, 1'b0, 1'b0, 1'b0, 1'b0, 1'b0, 1'b0, 1'b0, 1'b0, 1'b0, 1'b0, 1'b0, 1'b0, 1'b0, 1'b0, 1'b0, 1'b0, 1'b0, 1'b0, 1'b0, 1'b0, 1'b0, 1'b0, 1'b0, 1'b0, 1'b0/*aggregate*/}
                        : (aa_select[2] === 1'b1) ? 
                           {{a_msb,a_msb},reg_a}
                        : (aa_select[3] === 1'b1) ? 
                           {{a_msb,reg_a},1'b0}
                        :  reg_a_times3;
           
           assign {b_msb}=(reg_b[63] & sign_extend_sig);
           
           assign {bb}=(bb_select[0] === 1'b1) ? 
                           reg_b[33:0]
                        :  {(33-0+1- 0){1'bz}};
           
           assign {bb}=(bb_select[1] === 1'b1) ? 
                           {{b_msb,b_msb},reg_b[63:32]}
                        :  {(33-0+1- 0){1'bz}};
           
           assign {a_temp_sig}=(a_select[0] === 1'b1) ? 
                                   a
                                :  {(31-0+1- 0){1'bz}};
           
           assign {a_temp_sig}=(a_select[1] === 1'b1) ? 
                                   a_neg_sig
                                :  {(31-0+1- 0){1'bz}};
           
           assign {b_temp_sig}=(b_select[0] === 1'b1) ? 
                                   {{1'b0,b},zero[30:0]}
                                :  {(63-0+1- 0){1'bz}};
           
           assign {b_temp_sig}=(b_select[1] === 1'b1) ? 
                                   {{1'b0,b_neg_sig},zero[30:0]}
                                :  {(63-0+1- 0){1'bz}};
           
           assign {a_temp_sig}=(a_select[2] === 1'b1) ? 
                                   a
                                :  {(31-0+1- 0){1'bz}};
           
           assign {b_temp_sig}=(b_select[2] === 1'b1) ? 
                                   {zero,b}
                                :  {(63-0+1- 0){1'bz}};
           
           assign {a_temp_sig}=(a_select[3] === 1'b1) ? 
                                   a_neg_sig
                                :  {(31-0+1- 0){1'bz}};
           
           assign {b_temp_sig}=(b_select[3] === 1'b1) ? 
                                   {zero,b_neg_sig}
                                :  {(63-0+1- 0){1'bz}};
           
           assign {b_temp_sig}=(b_select[4] === 1'b1) ? 
                                   {reg_b[63:32],a}
                                :  {(63-0+1- 0){1'bz}};
           
           assign {b_temp_sig}=(b_select[5] === 1'b1) ? 
                                   {a,reg_b[31:0]}
                                :  {(63-0+1- 0){1'bz}};
           
           assign {a_temp_sig}=(a_select[4] === 1'b1) ? 
                                   sum[31:0]
                                :  {(31-0+1- 0){1'bz}};
           
           assign {b_temp_sig}=(b_select[6] === 1'b1) ? 
                                   {reg_b[63],reg_b[63:1]}
                                :  {(63-0+1- 0){1'bz}};
           
           assign {b_temp_sig}=(b_select[7] === 1'b1) ? 
                                   {a_temp_sig,answer_temp_sig}
                                :  {(63-0+1- 0){1'bz}};
           
           assign {b_temp_sig}=(b_select[8] === 1'b1) ? 
                                   {a_temp_sig,bv_negate__0(answer_temp_sig)}
                                :  {(63-0+1- 0){1'bz}};
           
           assign {b_temp_sig}=(((b_select[9] === 1'b1) & (b_select[10] === 1'b0)) & (b_select[11] === 1'b0)) ? 
                                   {sum,reg_b[31:2]}
                                :  {(63-0+1- 0){1'bz}};
           
           assign {b_temp_sig}=(b_select[10] === 1'b1) ? 
                                   {sum[33:2],reg_b[47:16]}
                                :  {(63-0+1- 0){1'bz}};
           
           assign {b_temp_sig}=(b_select[11] === 1'b1) ? 
                                   {sum[33:2],reg_b[55:24]}
                                :  {(63-0+1- 0){1'bz}};
           
           assign {a_temp_sig}=(a_select === 0) ? 
                                   reg_a
                                :  {(31-0+1- 0){1'bz}};
           
           assign {b_temp_sig}=(b_select === 0) ? 
                                   reg_b
                                :  {(63-0+1- 0){1'bz}};
           
           assign {answer_temp_sig}=(answer_select[0] === 1'b1) ? 
                                        32'b00000000000000000000000000000000
                                     : (answer_select[1] === 1'b1) ? 
                                        {answer_reg[30:0],1'b1}
                                     : (answer_select[2] === 1'b1) ? 
                                        {answer_reg[30:0],1'b0}
                                     :  answer_reg;
           
       end//generate if
   endgenerate
           assign aa = aa_;//Added for Conflict reslover.
    assign bb = bb_;//Added for Conflict reslover.
    assign sign_extend_sig = sign_extend_sig_;//Added for Conflict reslover.
       
       function [31:0] bv_negate__0;
           input  [31:0] a;
           reg carry_in;
           reg [31:0] not_a;
           reg [31:0] result;
           begin : Function
               begin 
                   result = 32'b00000000000000000000000000000000;
                   not_a = ~ (a);
                   carry_in = 1'b1;
                   begin :Block_Name_1
                       integer index;
                       for (index=0;index<=31;index=index+1) begin 
                           begin 
                               result[index] = (not_a[index] ^ carry_in);
                               carry_in = (carry_in & not_a[index]);
                           end
                           
                       end //for
                   end //end Block
                   begin 
                       bv_negate__0=result;
                       disable Function;
                   end
               end
           end // Function
       endfunction
           

       
       function [5:0] bv_inc6__1;
           input  [5:0] a;
           reg carry_in;
           reg [5:0] result;
           begin : Function
               begin 
                   result = 6'b000000;
                   carry_in = 1'b1;
                   begin :Block_Name_2
                       integer index;
                       for (index=0;index<=5;index=index+1) begin 
                           begin 
                               result[index] = (a[index] ^ carry_in);
                               carry_in = (a[index] & carry_in);
                           end
                           
                       end //for
                   end //end Block
                   begin 
                       bv_inc6__1=result;
                       disable Function;
                   end
               end
           end // Function
       endfunction
           

       
   
endmodule
//-------------------------------------------------------------------
// TITLE: Plasma Misc. Package
// AUTHOR: Steve Rhoads (rhoadss@yahoo.com)
// DATE CREATED: 2/15/01
// FILENAME: mlite_pack.vhd
// PROJECT: Plasma CPU core
// COPYRIGHT: Software placed into the public domain by the author.
//    Software 'as is' without warranty.  Author liable for nothing.
// DESCRIPTION:
//    Data types, constants, and add functions needed for the Plasma CPU.
//-------------------------------------------------------------------

//-------------------------------------------------------------------
// TITLE: Plasma CPU core
// AUTHOR: Steve Rhoads (rhoadss@yahoo.com)
// DATE CREATED: 2/15/01
// FILENAME: mlite_cpu.vhd
// PROJECT: Plasma CPU core
// COPYRIGHT: Software placed into the public domain by the author.
//    Software 'as is' without warranty.  Author liable for nothing.
// NOTE:  MIPS(tm) and MIPS I(tm) are registered trademarks of MIPS 
//    Technologies.  MIPS Technologies does not endorse and is not 
//    associated with this project.
// DESCRIPTION:
//    Top level VHDL document that ties the nine other entities together.
//
// Executes all MIPS I(tm) opcodes but exceptions and non-aligned
// memory accesses.  Based on information found in:
//    "MIPS RISC Architecture" by Gerry Kane and Joe Heinrich
//    and "The Designer's Guide to VHDL" by Peter J. Ashenden
//
// The CPU is implemented as a two or three stage pipeline.
// An add instruction would take the following steps (see cpu.gif):
// Stage #1:
//    1.  The "pc_next" entity passes the program counter (PC) to the 
//        "mem_ctrl" entity which fetches the opcode from memory.
// Stage #2:
//    2.  "Mem_ctrl" passes the opcode to the "control" entity.
//    3.  "Control" converts the 32-bit opcode to a 60-bit VLWI opcode
//        and sends control signals to the other entities.
//    4.  Based on the rs_index and rt_index control signals, "reg_bank" 
//        sends the 32-bit reg_source and reg_target to "bus_mux".
//    5.  Based on the a_source and b_source control signals, "bus_mux"
//        multiplexes reg_source onto a_bus and reg_target onto b_bus.
// Stage #3:
//    6.  Based on the alu_func control signals, "alu" adds the values
//        from a_bus and b_bus and places the result on c_bus.
//    7.  Based on the c_source control signals, "bus_bux" multiplexes
//        c_bus onto reg_dest.
//    8.  Based on the rd_index control signal, "reg_bank" saves
//        reg_dest into the correct register.
//
// All signals are active high.  Writing to high memory where a(31)='1' 
// takes five cycles to meet RAM address hold times.
// Addresses with a(31)='0' are assumed to be clocked and take three cycles.
// Here are the signals for writing a character to address 0xffff:
//
//      intr_in                        mem_pause    
//   reset_in                        mem_write      
//      clk                     mem_byte_sel        
//     ns    mem_address m_data_r m_data_w 
// =============================================
//   3000 1 0 0 0000002C A2820000 ZZZZZZZZ 0 0 0  (0 fetch write opcode)
//   3050 0 0 0 0000002C A2820000 ZZZZZZZZ 0 0 0
//   3100 1 0 0 00000030 340A0041 ZZZZZZZZ 0 0 0  (1 execute write opcode)
//   3150 0 0 0 00000030 340A0041 ZZZZZZZZ 0 0 0
//   3200 1 0 0 00000030 340A0041 ZZZZZZZZ 0 0 0  (2 calculating address)
//   3250 0 0 0 00000030 340A0041 ZZZZZZZZ 0 0 0
//   3300 1 0 0 0000FFFF ZZZZZZZZ 6A6A6A6A 1 1 0  (3 writing value)
//   3350 0 0 0 0000FFFF ZZZZZZZZ 6A6A6A6A 1 1 0
//   3400 1 0 0 00000034 340B0042 ZZZZZZZZ 0 0 0
//   3450 0 0 0 00000034 340B0042 ZZZZZZZZ 0 0 0
//
// Program:
// addr     value  opcode   args
// ===================================
// 002c  a2820000      sb   $v0,0($s4)
// 0030  340a0041      li   $t2,0x41
// 0034  340b0042      li   $t3,0x42
//-------------------------------------------------------------------


module  mlite_cpu ( clk, reset_in, intr_in, mem_address, mem_data_w, mem_data_r, mem_byte_sel, mem_write, mem_pause );
parameter memory_type="GENERIC";
parameter adder_type="GENERIC";
parameter mult_type="GENERIC";
parameter shifter_type="GENERIC";
parameter alu_type="GENERIC";
parameter  [31:0]  pipeline_stages =3;
parameter  accurate_timing =1'b1;
         parameter [31:0] zero=32'b00000000000000000000000000000000;
     parameter [31:0] ones=32'b11111111111111111111111111111111;
     parameter [31:0] high_z=32'bZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ;
     parameter [3:0] alu_nothing=4'b0000;
     parameter [3:0] alu_add=4'b0001;
     parameter [3:0] alu_subtract=4'b0010;
     parameter [3:0] alu_less_than=4'b0011;
     parameter [3:0] alu_less_than_signed=4'b0100;
     parameter [3:0] alu_or=4'b0101;
     parameter [3:0] alu_and=4'b0110;
     parameter [3:0] alu_xor=4'b0111;
     parameter [3:0] alu_nor=4'b1000;
     parameter [1:0] shift_nothing=2'b00;
     parameter [1:0] shift_left_unsigned=2'b01;
     parameter [1:0] shift_right_signed=2'b11;
     parameter [1:0] shift_right_unsigned=2'b10;
     parameter [3:0] mult_nothing=4'b0000;
     parameter [3:0] mult_read_lo=4'b0001;
     parameter [3:0] mult_read_hi=4'b0010;
     parameter [3:0] mult_write_lo=4'b0011;
     parameter [3:0] mult_write_hi=4'b0100;
     parameter [3:0] mult_mult=4'b0101;
     parameter [3:0] mult_signed_mult=4'b0110;
     parameter [3:0] mult_divide=4'b0111;
     parameter [3:0] mult_signed_divide=4'b1000;
     parameter [1:0] a_from_reg_source=2'b00;
     parameter [1:0] a_from_imm10_6=2'b01;
     parameter [1:0] a_from_pc=2'b10;
     parameter [1:0] b_from_reg_target=2'b00;
     parameter [1:0] b_from_imm=2'b01;
     parameter [1:0] b_from_signed_imm=2'b10;
     parameter [1:0] b_from_immx4=2'b11;
     parameter [2:0] c_from_null=3'b000;
     parameter [2:0] c_from_alu=3'b001;
     parameter [2:0] c_from_shift=3'b001;
     parameter [2:0] c_from_mult=3'b001;
     parameter [2:0] c_from_memory=3'b010;
     parameter [2:0] c_from_pc=3'b011;
     parameter [2:0] c_from_pc_plus4=3'b100;
     parameter [2:0] c_from_imm_shift16=3'b101;
     parameter [2:0] c_from_reg_sourcen=3'b110;
     parameter [1:0] from_inc4=2'b00;
     parameter [1:0] from_opcode25_0=2'b01;
     parameter [1:0] from_branch=2'b10;
     parameter [1:0] from_lbranch=2'b11;
     parameter [2:0] branch_ltz=3'b000;
     parameter [2:0] branch_lez=3'b001;
     parameter [2:0] branch_eq=3'b010;
     parameter [2:0] branch_ne=3'b011;
     parameter [2:0] branch_gez=3'b100;
     parameter [2:0] branch_gtz=3'b101;
     parameter [2:0] branch_yes=3'b110;
     parameter [3:0] mem_fetch=4'b0000;
     parameter [3:0] mem_read32=4'b0100;
     parameter [3:0] mem_write32=4'b0101;
     parameter [3:0] mem_read16=4'b1000;
     parameter [3:0] mem_read16s=4'b1010;
     parameter [3:0] mem_write16=4'b1001;
     parameter [3:0] mem_read8=4'b1100;
     parameter [3:0] mem_read8s=4'b1110;
     parameter [3:0] mem_write8=4'b1101;

    input clk;
    input reset_in;
    input intr_in;
    output [31:0]  mem_address ;
    output [31:0]  mem_data_w ;
    input [31:0]  mem_data_r ;
    output [3:0]  mem_byte_sel ;
    output mem_write;
    input mem_pause;


    wire [31:0] opcode;
    wire [5:0] rs_index;
    wire [5:0] rt_index;
    wire [5:0] rd_index;
    wire [5:0] rd_indexd;
    wire [31:0] reg_source;
    wire [31:0] reg_target;
    wire [31:0] reg_dest;
    wire [31:0] reg_destd;
    wire [31:0] a_bus;
    wire [31:0] a_busd;
    wire [31:0] b_bus;
    wire [31:0] b_busd;
    wire [31:0] c_bus;
    wire [31:0] c_alu;
    wire [31:0] c_shift;
    wire [31:0] c_mult;
    wire [31:0] c_memory;
    wire [15:0] imm;
    wire [31:0] pc;
    wire [31:0] pc_plus4;
    wire [3:0] alu_func;
    wire [3:0] alu_funcd;
    wire [1:0] shift_func;
    wire [1:0] shift_funcd;
    wire [3:0] mult_func;
    wire [3:0] mult_funcd;
    wire [2:0] branch_func;
    wire take_branch;
    wire [1:0] a_source;
    wire [1:0] b_source;
    wire [2:0] c_source;
    wire [1:0] pc_source;
    wire [3:0] mem_source;
    wire pause_mult;
    wire pause_ctrl;
    wire pause_pipeline;
    wire pause_any;
    wire pause_non_ctrl;
    wire pause_bank;
    wire nullify_op;
    wire intr_enable;
    reg intr_signal;
    reg [3:0] reset_reg;
    wire reset;
    wire [31:0] mem_address;
    wire [31:0] mem_data_w;
    wire [3:0] mem_byte_sel;
    wire mem_write;


    
   assign {pause_any}=((mem_pause | pause_ctrl) | (pause_mult | pause_pipeline));
   
   assign {pause_non_ctrl}=((mem_pause | pause_mult) | pause_pipeline);
   
   assign {pause_bank}=(((mem_pause | pause_ctrl) | pause_mult) & ~ (pause_pipeline));
   
   assign {nullify_op}=(((pc_source === from_lbranch) & (take_branch === 1'b0)) | (intr_signal === 1'b1)) ? 
                           1'b1
                        :  1'b0;
   
   assign {c_bus}=((c_alu | c_shift) | c_mult);
   
   assign {reset}=((reset_in === 1'b1) | (!(reset_reg===4'b1111))) ? 
                      1'b1
                   :  1'b0;
   
   always @ (posedge clk or posedge reset_in ) begin
       if ((reset_in === 1'b1)) 
           begin 
               reset_reg <= 4'b0000;
               intr_signal <= 1'b0;
           end
           
       else 
           begin 
               begin 
                   if ((!(reset_reg===4'b1111))) 
                       reset_reg <= (reset_reg + 1);
                       
                   
                   if ((pause_any === 1'b0)) 
                       begin 
                               if (((((intr_in === 1'b1) & (intr_enable === 1'b1)) & (pc_source === from_inc4)) & (pc[2] === 1'b0))) 
                                       intr_signal <= 1'b1;
                               else 
                                       intr_signal <= 1'b0;

                               
                       end 
                   
                   
               end
               
           end 
       
   end //always
       
   pc_next u1_pc_next(.clk(clk), .reset_in(reset), .pc_new(c_bus[31:2]), .take_branch(take_branch), .pause_in(pause_any), .opcode25_0(opcode[25:0]), .pc_source(pc_source), .pc_out(pc), .pc_out_plus4(pc_plus4));
   
   mem_ctrl  #(.accurate_timing(accurate_timing)) u2_mem_ctrl(.clk(clk), .reset_in(reset), .pause_in(pause_non_ctrl), .nullify_op(nullify_op), .address_pc(pc), .opcode_out(opcode), .address_data(c_bus), .mem_source(mem_source), .data_write(reg_target), .data_read(c_memory), .pause_out(pause_ctrl), .mem_address(mem_address), .mem_data_w(mem_data_w), .mem_data_r(mem_data_r), .mem_byte_sel(mem_byte_sel), .mem_write(mem_write));
   //Parameter Order: accurate_timing 

   control u3_control(.opcode(opcode), .intr_signal(intr_signal), .rs_index(rs_index), .rt_index(rt_index), .rd_index(rd_index), .imm_out(imm), .alu_func(alu_func), .shift_func(shift_func), .mult_func(mult_func), .branch_func(branch_func), .a_source_out(a_source), .b_source_out(b_source), .c_source_out(c_source), .pc_source_out(pc_source), .mem_source_out(mem_source));
   
   reg_bank  #(.memory_type(memory_type)) u4_reg_bank(.clk(clk), .reset_in(reset), .pause(pause_bank), .rs_index(rs_index), .rt_index(rt_index), .rd_index(rd_indexd), .reg_source_out(reg_source), .reg_target_out(reg_target), .reg_dest_new(reg_destd), .intr_enable(intr_enable));
   //Parameter Order: memory_type 

   bus_mux u5_bus_mux(.imm_in(imm), .reg_source(reg_source), .a_mux(a_source), .a_out(a_bus), .reg_target(reg_target), .b_mux(b_source), .b_out(b_bus), .c_bus(c_bus), .c_memory(c_memory), .c_pc(pc), .c_pc_plus4(pc_plus4), .c_mux(c_source), .reg_dest_out(reg_dest), .branch_func(branch_func), .take_branch(take_branch));
   
   alu  #(.adder_type(adder_type),.alu_type(alu_type)) u6_alu(.a_in(a_busd), .b_in(b_busd), .alu_function(alu_funcd), .c_alu(c_alu));
   //Parameter Order: adder_type,alu_type 

   shifter  #(.shifter_type(shifter_type)) u7_shifter(.value(b_busd), .shift_amount(a_busd[4:0]), .shift_func(shift_funcd), .c_shift(c_shift));
   //Parameter Order: shifter_type 

   mult  #(.adder_type(adder_type),.mult_type(mult_type)) u8_mult(.clk(clk), .a(a_busd), .b(b_busd), .mult_func(mult_funcd), .c_mult(c_mult), .pause_out(pause_mult));
   //Parameter Order: adder_type,mult_type 

   
   generate
       if ((pipeline_stages <= 2))begin//generate if 
               
           assign {a_busd}=a_bus;
           
           assign {b_busd}=b_bus;
           
           assign {alu_funcd}=alu_func;
           
           assign {shift_funcd}=shift_func;
           
           assign {mult_funcd}=mult_func;
           
           assign {rd_indexd}=rd_index;
           
           assign {reg_destd}=reg_dest;
           
           assign {pause_pipeline}=1'b0;
           
       end//generate if
   endgenerate
   
   
   generate
       if ((pipeline_stages >= 3))begin//generate if 
               
           pipeline u9_pipeline(.clk(clk), .reset(reset), .a_bus(a_bus), .a_busd(a_busd), .b_bus(b_bus), .b_busd(b_busd), .alu_func(alu_func), .alu_funcd(alu_funcd), .shift_func(shift_func), .shift_funcd(shift_funcd), .mult_func(mult_func), .mult_funcd(mult_funcd), .reg_dest(reg_dest), .reg_destd(reg_destd), .rd_index(rd_index), .rd_indexd(rd_indexd), .rs_index(rs_index), .rt_index(rt_index), .pc_source(pc_source), .mem_source(mem_source), .a_source(a_source), .b_source(b_source), .c_source(c_source), .c_bus(c_bus), .pause_any(pause_any), .pause_pipeline(pause_pipeline));
           
       end//generate if
   endgenerate
    

endmodule
//-------------------------------------------------------------------
// TITLE: Memory Controller
// AUTHOR: Steve Rhoads (rhoadss@yahoo.com)
// DATE CREATED: 1/31/01
// FILENAME: mem_ctrl.vhd
// PROJECT: Plasma CPU core
// COPYRIGHT: Software placed into the public domain by the author.
//    Software 'as is' without warranty.  Author liable for nothing.
// DESCRIPTION:
//    Memory controller for the Plasma CPU.
//    Supports Big or Little Endian mode.
//    Four cycles for a write unless a(31)='1' then two cycles.
//    This entity could implement interfaces to:
//       Data cache
//       Address cache
//       Memory management unit (MMU)
//       DRAM controller
//-------------------------------------------------------------------


module  mem_ctrl ( clk, reset_in, pause_in, nullify_op, address_pc, opcode_out, address_data, mem_source, data_write, data_read, pause_out, mem_address, mem_data_w, mem_data_r, mem_byte_sel, mem_write );
parameter  accurate_timing =1'b0;
         parameter [31:0] zero=32'b00000000000000000000000000000000;
     parameter [31:0] ones=32'b11111111111111111111111111111111;
     parameter [31:0] high_z=32'bZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ;
     parameter [3:0] alu_nothing=4'b0000;
     parameter [3:0] alu_add=4'b0001;
     parameter [3:0] alu_subtract=4'b0010;
     parameter [3:0] alu_less_than=4'b0011;
     parameter [3:0] alu_less_than_signed=4'b0100;
     parameter [3:0] alu_or=4'b0101;
     parameter [3:0] alu_and=4'b0110;
     parameter [3:0] alu_xor=4'b0111;
     parameter [3:0] alu_nor=4'b1000;
     parameter [1:0] shift_nothing=2'b00;
     parameter [1:0] shift_left_unsigned=2'b01;
     parameter [1:0] shift_right_signed=2'b11;
     parameter [1:0] shift_right_unsigned=2'b10;
     parameter [3:0] mult_nothing=4'b0000;
     parameter [3:0] mult_read_lo=4'b0001;
     parameter [3:0] mult_read_hi=4'b0010;
     parameter [3:0] mult_write_lo=4'b0011;
     parameter [3:0] mult_write_hi=4'b0100;
     parameter [3:0] mult_mult=4'b0101;
     parameter [3:0] mult_signed_mult=4'b0110;
     parameter [3:0] mult_divide=4'b0111;
     parameter [3:0] mult_signed_divide=4'b1000;
     parameter [1:0] a_from_reg_source=2'b00;
     parameter [1:0] a_from_imm10_6=2'b01;
     parameter [1:0] a_from_pc=2'b10;
     parameter [1:0] b_from_reg_target=2'b00;
     parameter [1:0] b_from_imm=2'b01;
     parameter [1:0] b_from_signed_imm=2'b10;
     parameter [1:0] b_from_immx4=2'b11;
     parameter [2:0] c_from_null=3'b000;
     parameter [2:0] c_from_alu=3'b001;
     parameter [2:0] c_from_shift=3'b001;
     parameter [2:0] c_from_mult=3'b001;
     parameter [2:0] c_from_memory=3'b010;
     parameter [2:0] c_from_pc=3'b011;
     parameter [2:0] c_from_pc_plus4=3'b100;
     parameter [2:0] c_from_imm_shift16=3'b101;
     parameter [2:0] c_from_reg_sourcen=3'b110;
     parameter [1:0] from_inc4=2'b00;
     parameter [1:0] from_opcode25_0=2'b01;
     parameter [1:0] from_branch=2'b10;
     parameter [1:0] from_lbranch=2'b11;
     parameter [2:0] branch_ltz=3'b000;
     parameter [2:0] branch_lez=3'b001;
     parameter [2:0] branch_eq=3'b010;
     parameter [2:0] branch_ne=3'b011;
     parameter [2:0] branch_gez=3'b100;
     parameter [2:0] branch_gtz=3'b101;
     parameter [2:0] branch_yes=3'b110;
     parameter [3:0] mem_fetch=4'b0000;
     parameter [3:0] mem_read32=4'b0100;
     parameter [3:0] mem_write32=4'b0101;
     parameter [3:0] mem_read16=4'b1000;
     parameter [3:0] mem_read16s=4'b1010;
     parameter [3:0] mem_write16=4'b1001;
     parameter [3:0] mem_read8=4'b1100;
     parameter [3:0] mem_read8s=4'b1110;
     parameter [3:0] mem_write8=4'b1101;

    input clk;
    input reset_in;
    input pause_in;
    input nullify_op;
    input [31:0]  address_pc ;
    output [31:0]  opcode_out ;
    input [31:0]  address_data ;
    input [3:0]  mem_source ;
    input [31:0]  data_write ;
    output [31:0]  data_read ;
    output pause_out;
    output [31:0]  mem_address ;
    output [31:0]  mem_data_w ;
    input [31:0]  mem_data_r ;
    output [3:0]  mem_byte_sel ;
    output mem_write;


    reg [31:0] mem_proc__data;
    reg [31:0] mem_proc__opcode_next;
    reg [3:0] mem_proc__byte_sel_next;
    reg [3:0] mem_proc__byte_sel;
    reg mem_proc__write_next;
    reg mem_proc__write_line;
    reg [1:0] mem_proc__mem_state_next;
    reg mem_proc__pause;
    reg [31:0] mem_proc__address;
    reg [1:0] mem_proc__bits;
    reg [31:0] mem_proc__mem_data_w_v;
    parameter [1:0] little_endian=2'b00;
    reg [31:0] opcode_reg;
    reg [31:0] next_opcode_reg;
    reg [1:0] mem_state_reg;
    parameter [1:0] state_fetch=2'b00;
    parameter [1:0] state_addr=2'b01;
    parameter [1:0] state_write=2'b10;
    parameter [1:0] state_pause=2'b11;
    reg [31:0] address_reg;
    reg write_reg;
    reg [3:0] byte_sel_reg;
    reg [1:0] mem_state_next_sig;
    reg [31:0] opcode_next_sig;
    reg write_next_sig;
    reg [3:0] byte_sel_next_sig;
    reg [31:0] opcode_out;
    reg [31:0] data_read;
    reg pause_out;
    reg [31:0] mem_address;
    reg [31:0] mem_data_w;
    reg [3:0] mem_byte_sel;
    reg mem_write;


    
       
   always @ (posedge clk or posedge reset_in ) begin
           if ((reset_in === 1'b1)) 
               begin 
                   mem_state_reg <= 2'b00;
                   opcode_reg <= 32'b00000000000000000000000000000000;
                   next_opcode_reg <= 32'b00000000000000000000000000000000;
               end
               
           else 
               begin 
                   mem_state_reg <= mem_state_next_sig;
                   opcode_reg <= opcode_next_sig;
                   if ((mem_state_reg === state_fetch)) 
                       next_opcode_reg <= mem_data_r;
                       
                   
                   
               end
               
           
   end //always
   
   always @ (posedge clk ) begin
           begin 
               if (accurate_timing) 
                   begin 
                       address_reg <= address_data;
                       write_reg <= write_next_sig;
                       byte_sel_reg <= byte_sel_next_sig;
                   end
                   
               
               
           end 
       
   end //always
       
   always @ (clk or address_data or write_next_sig or byte_sel_next_sig ) begin
       begin 
           if (~ (accurate_timing)) 
               begin 
                   address_reg <= address_data;
                   write_reg <= write_next_sig;
                   byte_sel_reg <= byte_sel_next_sig;
               end
               
           
       end 
   end //always
   
       
   always @ (clk or reset_in or pause_in or nullify_op or address_pc or address_data or mem_source or data_write or mem_data_r or opcode_reg or next_opcode_reg or mem_state_reg or address_reg or write_reg or byte_sel_reg ) begin
       begin 
           mem_proc__byte_sel_next = 4'b0000;
           mem_proc__write_next = 1'b0;
           mem_proc__pause = 1'b0;
           mem_proc__mem_state_next = mem_state_reg;
           mem_proc__data = 32'b00000000000000000000000000000000;
           mem_proc__mem_data_w_v = 32'b00000000000000000000000000000000;
           case (mem_source)
               4'b0100 : 
                       mem_proc__data = mem_data_r;
               4'b1000,4'b1010 : 
                   begin 
                       if ((address_reg[1] === little_endian[1])) 
                               mem_proc__data[15:0] = mem_data_r[31:16];
                       else 
                               mem_proc__data[15:0] = mem_data_r[15:0];

                       if (((mem_source === mem_read16) | (mem_proc__data[15] === 1'b0))) 
                               mem_proc__data[31:16] = zero[31:16];
                       else 
                               mem_proc__data[31:16] = ones[31:16];

                       
                   end
               4'b1100,4'b1110 : 
                   begin 
                       mem_proc__bits = (address_reg[1:0] ^ little_endian);
                       case (mem_proc__bits)
                           2'b00 : 
                                   mem_proc__data[7:0] = mem_data_r[31:24];
                           2'b01 : 
                                   mem_proc__data[7:0] = mem_data_r[23:16];
                           2'b10 : 
                                   mem_proc__data[7:0] = mem_data_r[15:8];
                           default : 
                                   mem_proc__data[7:0] = mem_data_r[7:0];
                       endcase
                       if (((mem_source === mem_read8) | (mem_proc__data[7] === 1'b0))) 
                               mem_proc__data[31:8] = zero[31:8];
                       else 
                               mem_proc__data[31:8] = ones[31:8];

                       
                   end
               4'b0101 : 
                   begin 
                       mem_proc__write_next = 1'b1;
                       mem_proc__mem_data_w_v = data_write;
                       mem_proc__byte_sel_next = 4'b1111;
                   end
               4'b1001 : 
                   begin 
                       mem_proc__write_next = 1'b1;
                       mem_proc__mem_data_w_v = {data_write[15:0],data_write[15:0]};
                       if ((address_data[1] === little_endian[1])) 
                               mem_proc__byte_sel_next = 4'b1100;
                       else 
                               mem_proc__byte_sel_next = 4'b0011;

                       
                   end
               4'b1101 : 
                   begin 
                       mem_proc__write_next = 1'b1;
                       mem_proc__mem_data_w_v = {{{data_write[7:0],data_write[7:0]},data_write[7:0]},data_write[7:0]};
                       mem_proc__bits = (address_data[1:0] ^ little_endian);
                       case (mem_proc__bits)
                           2'b00 : 
                                   mem_proc__byte_sel_next = 4'b1000;
                           2'b01 : 
                                   mem_proc__byte_sel_next = 4'b0100;
                           2'b10 : 
                                   mem_proc__byte_sel_next = 4'b0010;
                           default : 
                                   mem_proc__byte_sel_next = 4'b0001;
                       endcase
                   end
               default : 
                   ;
           endcase
           byte_sel_next_sig <= mem_proc__byte_sel_next;
           write_next_sig <= mem_proc__write_next;
           mem_proc__opcode_next = opcode_reg;
           case (mem_state_reg)
               2'b00 : 
                   begin 
                       mem_proc__address = address_pc;
                       mem_proc__write_line = 1'b0;
                       mem_proc__byte_sel = 4'b0000;
                       if ((mem_source === mem_fetch)) 
                           begin 
                               mem_proc__mem_state_next = 2'b00;
                               if ((pause_in === 1'b0)) 
                                       mem_proc__opcode_next = mem_data_r;

                               
                           end
                       else 
                           begin 
                               mem_proc__pause = 1'b1;
                               if ((pause_in === 1'b0)) 
                                       mem_proc__mem_state_next = 2'b01;

                               
                           end

                       
                   end
               2'b01 : 
                   begin 
                       mem_proc__address = address_reg;
                       mem_proc__write_line = write_reg;
                       if (((write_reg === 1'b1) & (address_reg[31] === 1'b1))) 
                           begin 
                               mem_proc__pause = 1'b1;
                               mem_proc__byte_sel = 4'b0000;
                               if ((pause_in === 1'b0)) 
                                       mem_proc__mem_state_next = 2'b10;

                               
                           end
                       else 
                           begin 
                               mem_proc__byte_sel = byte_sel_reg;
                               if ((pause_in === 1'b0)) 
                                   begin 
                                       mem_proc__opcode_next = next_opcode_reg;
                                       mem_proc__mem_state_next = 2'b00;
                                   end

                               
                           end

                       
                   end
               2'b10 : 
                   begin 
                       mem_proc__pause = 1'b1;
                       mem_proc__address = address_reg;
                       mem_proc__write_line = write_reg;
                       mem_proc__byte_sel = byte_sel_reg;
                       if ((pause_in === 1'b0)) 
                               mem_proc__mem_state_next = 2'b11;

                       
                   end
               default : 
                   begin 
                       mem_proc__address = address_reg;
                       mem_proc__write_line = write_reg;
                       mem_proc__byte_sel = 4'b0000;
                       if ((pause_in === 1'b0)) 
                           begin 
                               mem_proc__opcode_next = next_opcode_reg;
                               mem_proc__mem_state_next = 2'b00;
                           end

                       
                   end
           endcase
           if (((nullify_op === 1'b1) & (pause_in === 1'b0))) 
               mem_proc__opcode_next = 32'b00000000000000000000000000000000;
               
           mem_state_next_sig <= mem_proc__mem_state_next;
           opcode_next_sig <= mem_proc__opcode_next;
           if ((reset_in === 1'b1)) 
               mem_proc__write_line = 1'b0;
               
           opcode_out <= opcode_reg;
           data_read <= mem_proc__data;
           pause_out <= mem_proc__pause;
           mem_byte_sel <= mem_proc__byte_sel;
           mem_address <= mem_proc__address;
           mem_write <= mem_proc__write_line;
           if ((mem_proc__write_line === 1'b1)) 
               mem_data_w <= mem_proc__mem_data_w_v;
               
           else 
               mem_data_w <= 32'bZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ;
               
           
       end 
   end //always
    

endmodule
//-------------------------------------------------------------------
// TITLE: Controller / Opcode Decoder
// AUTHOR: Steve Rhoads (rhoadss@yahoo.com)
// DATE CREATED: 2/8/01
// FILENAME: control.vhd
// PROJECT: Plasma CPU core
// COPYRIGHT: Software placed into the public domain by the author.
//    Software 'as is' without warranty.  Author liable for nothing.
// NOTE:  MIPS(tm) is a registered trademark of MIPS Technologies.
//    MIPS Technologies does not endorse and is not associated with
//    this project.
// DESCRIPTION:
//    Controls the CPU by decoding the opcode and generating control 
//    signals to the rest of the CPU.
//    This entity decodes the MIPS(tm) opcode into a 
//    Very-Long-Word-Instruction.  
//    The 32-bit opcode is converted to a 
//       6+6+6+16+5+2+3+3+2+2+3+2+4 = 60 bit VLWI opcode.
//    Based on information found in:
//       "MIPS RISC Architecture" by Gerry Kane and Joe Heinrich
//       and "The Designer's Guide to VHDL" by Peter J. Ashenden
//-------------------------------------------------------------------


module  control ( opcode, intr_signal, rs_index, rt_index, rd_index, imm_out, alu_func, shift_func, mult_func, branch_func, a_source_out, b_source_out, c_source_out, pc_source_out, mem_source_out );
         parameter [31:0] zero=32'b00000000000000000000000000000000;
     parameter [31:0] ones=32'b11111111111111111111111111111111;
     parameter [31:0] high_z=32'bZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ;
     parameter [3:0] alu_nothing=4'b0000;
     parameter [3:0] alu_add=4'b0001;
     parameter [3:0] alu_subtract=4'b0010;
     parameter [3:0] alu_less_than=4'b0011;
     parameter [3:0] alu_less_than_signed=4'b0100;
     parameter [3:0] alu_or=4'b0101;
     parameter [3:0] alu_and=4'b0110;
     parameter [3:0] alu_xor=4'b0111;
     parameter [3:0] alu_nor=4'b1000;
     parameter [1:0] shift_nothing=2'b00;
     parameter [1:0] shift_left_unsigned=2'b01;
     parameter [1:0] shift_right_signed=2'b11;
     parameter [1:0] shift_right_unsigned=2'b10;
     parameter [3:0] mult_nothing=4'b0000;
     parameter [3:0] mult_read_lo=4'b0001;
     parameter [3:0] mult_read_hi=4'b0010;
     parameter [3:0] mult_write_lo=4'b0011;
     parameter [3:0] mult_write_hi=4'b0100;
     parameter [3:0] mult_mult=4'b0101;
     parameter [3:0] mult_signed_mult=4'b0110;
     parameter [3:0] mult_divide=4'b0111;
     parameter [3:0] mult_signed_divide=4'b1000;
     parameter [1:0] a_from_reg_source=2'b00;
     parameter [1:0] a_from_imm10_6=2'b01;
     parameter [1:0] a_from_pc=2'b10;
     parameter [1:0] b_from_reg_target=2'b00;
     parameter [1:0] b_from_imm=2'b01;
     parameter [1:0] b_from_signed_imm=2'b10;
     parameter [1:0] b_from_immx4=2'b11;
     parameter [2:0] c_from_null=3'b000;
     parameter [2:0] c_from_alu=3'b001;
     parameter [2:0] c_from_shift=3'b001;
     parameter [2:0] c_from_mult=3'b001;
     parameter [2:0] c_from_memory=3'b010;
     parameter [2:0] c_from_pc=3'b011;
     parameter [2:0] c_from_pc_plus4=3'b100;
     parameter [2:0] c_from_imm_shift16=3'b101;
     parameter [2:0] c_from_reg_sourcen=3'b110;
     parameter [1:0] from_inc4=2'b00;
     parameter [1:0] from_opcode25_0=2'b01;
     parameter [1:0] from_branch=2'b10;
     parameter [1:0] from_lbranch=2'b11;
     parameter [2:0] branch_ltz=3'b000;
     parameter [2:0] branch_lez=3'b001;
     parameter [2:0] branch_eq=3'b010;
     parameter [2:0] branch_ne=3'b011;
     parameter [2:0] branch_gez=3'b100;
     parameter [2:0] branch_gtz=3'b101;
     parameter [2:0] branch_yes=3'b110;
     parameter [3:0] mem_fetch=4'b0000;
     parameter [3:0] mem_read32=4'b0100;
     parameter [3:0] mem_write32=4'b0101;
     parameter [3:0] mem_read16=4'b1000;
     parameter [3:0] mem_read16s=4'b1010;
     parameter [3:0] mem_write16=4'b1001;
     parameter [3:0] mem_read8=4'b1100;
     parameter [3:0] mem_read8s=4'b1110;
     parameter [3:0] mem_write8=4'b1101;

    input [31:0]  opcode ;
    input intr_signal;
    output [5:0]  rs_index ;
    output [5:0]  rt_index ;
    output [5:0]  rd_index ;
    output [15:0]  imm_out ;
    output [3:0]  alu_func ;
    output [1:0]  shift_func ;
    output [3:0]  mult_func ;
    output [2:0]  branch_func ;
    output [1:0]  a_source_out ;
    output [1:0]  b_source_out ;
    output [2:0]  c_source_out ;
    output [1:0]  pc_source_out ;
    output [3:0]  mem_source_out ;


    reg [5:0] control_proc__op;
    reg [5:0] control_proc__func;
    reg [5:0] control_proc__rs;
    reg [5:0] control_proc__rt;
    reg [5:0] control_proc__rd;
    reg [4:0] control_proc__rtx;
    reg [15:0] control_proc__imm;
    reg [3:0] control_proc__alu_function;
    reg [1:0] control_proc__shift_function;
    reg [3:0] control_proc__mult_function;
    reg [1:0] control_proc__a_source;
    reg [1:0] control_proc__b_source;
    reg [2:0] control_proc__c_source;
    reg [1:0] control_proc__pc_source;
    reg [2:0] control_proc__branch_function;
    reg [3:0] control_proc__mem_source;
    reg [5:0] rs_index;
    reg [5:0] rt_index;
    reg [5:0] rd_index;
    reg [15:0] imm_out;
    reg [3:0] alu_func;
    reg [1:0] shift_func;
    reg [3:0] mult_func;
    reg [2:0] branch_func;
    reg [1:0] a_source_out;
    reg [1:0] b_source_out;
    reg [2:0] c_source_out;
    reg [1:0] pc_source_out;
    reg [3:0] mem_source_out;


    
       
   always @ (opcode or intr_signal ) begin
       begin 
           control_proc__alu_function = 4'b0000;
           control_proc__shift_function = 2'b00;
           control_proc__mult_function = 4'b0000;
           control_proc__a_source = 2'b00;
           control_proc__b_source = 2'b00;
           control_proc__c_source = 3'b000;
           control_proc__pc_source = 2'b00;
           control_proc__branch_function = 3'b010;
           control_proc__mem_source = 4'b0000;
           control_proc__op = opcode[31:26];
           control_proc__rs = {1'b0,opcode[25:21]};
           control_proc__rt = {1'b0,opcode[20:16]};
           control_proc__rtx = opcode[20:16];
           control_proc__rd = {1'b0,opcode[15:11]};
           control_proc__func = opcode[5:0];
           control_proc__imm = opcode[15:0];
           case (control_proc__op)
               6'b000000 : 
                       case (control_proc__func)
                           6'b000000 : 
                               begin 
                                   control_proc__a_source = 2'b01;
                                   control_proc__c_source = 3'b001;
                                   control_proc__shift_function = 2'b01;
                               end
                           6'b000010 : 
                               begin 
                                   control_proc__a_source = 2'b01;
                                   control_proc__c_source = 3'b001;
                                   control_proc__shift_function = 2'b10;
                               end
                           6'b000011 : 
                               begin 
                                   control_proc__a_source = 2'b01;
                                   control_proc__c_source = 3'b001;
                                   control_proc__shift_function = 2'b11;
                               end
                           6'b000100 : 
                               begin 
                                   control_proc__c_source = 3'b001;
                                   control_proc__shift_function = 2'b01;
                               end
                           6'b000110 : 
                               begin 
                                   control_proc__c_source = 3'b001;
                                   control_proc__shift_function = 2'b10;
                               end
                           6'b000111 : 
                               begin 
                                   control_proc__c_source = 3'b001;
                                   control_proc__shift_function = 2'b11;
                               end
                           6'b001000 : 
                               begin 
                                   control_proc__pc_source = 2'b10;
                                   control_proc__alu_function = 4'b0001;
                                   control_proc__branch_function = 3'b110;
                               end
                           6'b001001 : 
                               begin 
                                   control_proc__c_source = 3'b100;
                                   control_proc__pc_source = 2'b10;
                                   control_proc__alu_function = 4'b0001;
                                   control_proc__branch_function = 3'b110;
                               end
                           6'b001010: ;
                           6'b001011: ;
                           6'b001100: ;
                           6'b001101: ;
                           6'b001111: ;
                           6'b010000 : 
                               begin 
                                   control_proc__c_source = 3'b001;
                                   control_proc__mult_function = 4'b0010;
                               end
                           6'b010001 : 
                                   control_proc__mult_function = 4'b0100;
                           6'b010010 : 
                               begin 
                                   control_proc__c_source = 3'b001;
                                   control_proc__mult_function = 4'b0001;
                               end
                           6'b010011 : 
                                   control_proc__mult_function = 4'b0011;
                           6'b011000 : 
                                   control_proc__mult_function = 4'b0110;
                           6'b011001 : 
                                   control_proc__mult_function = 4'b0101;
                           6'b011010 : 
                                   control_proc__mult_function = 4'b1000;
                           6'b011011 : 
                                   control_proc__mult_function = 4'b0111;
                           6'b100000 : 
                               begin 
                                   control_proc__c_source = 3'b001;
                                   control_proc__alu_function = 4'b0001;
                               end
                           6'b100001 : 
                               begin 
                                   control_proc__c_source = 3'b001;
                                   control_proc__alu_function = 4'b0001;
                               end
                           6'b100010 : 
                               begin 
                                   control_proc__c_source = 3'b001;
                                   control_proc__alu_function = 4'b0010;
                               end
                           6'b100011 : 
                               begin 
                                   control_proc__c_source = 3'b001;
                                   control_proc__alu_function = 4'b0010;
                               end
                           6'b100100 : 
                               begin 
                                   control_proc__c_source = 3'b001;
                                   control_proc__alu_function = 4'b0110;
                               end
                           6'b100101 : 
                               begin 
                                   control_proc__c_source = 3'b001;
                                   control_proc__alu_function = 4'b0101;
                               end
                           6'b100110 : 
                               begin 
                                   control_proc__c_source = 3'b001;
                                   control_proc__alu_function = 4'b0111;
                               end
                           6'b100111 : 
                               begin 
                                   control_proc__c_source = 3'b001;
                                   control_proc__alu_function = 4'b1000;
                               end
                           6'b101010 : 
                               begin 
                                   control_proc__c_source = 3'b001;
                                   control_proc__alu_function = 4'b0100;
                               end
                           6'b101011 : 
                               begin 
                                   control_proc__c_source = 3'b001;
                                   control_proc__alu_function = 4'b0011;
                               end
                           6'b101101 : 
                               begin 
                                   control_proc__c_source = 3'b001;
                                   control_proc__alu_function = 4'b0001;
                               end
                           6'b110001: ;
                           6'b110010: ;
                           6'b110011: ;
                           6'b110100: ;
                           6'b110110 : 
                               ;
                           default : 
                               ;
                       endcase
               6'b000001 : 
                   begin 
                       control_proc__rt = 6'b000000;
                       control_proc__rd = 6'b011111;
                       control_proc__a_source = 2'b10;
                       control_proc__b_source = 2'b11;
                       control_proc__alu_function = 4'b0001;
                       control_proc__pc_source = 2'b10;
                       control_proc__branch_function = 3'b101;
                       case (control_proc__rtx)
                           5'b10000 : 
                               begin 
                                   control_proc__c_source = 3'b100;
                                   control_proc__branch_function = 3'b000;
                               end
                           5'b00000 : 
                                   control_proc__branch_function = 3'b000;
                           5'b10001 : 
                               begin 
                                   control_proc__c_source = 3'b100;
                                   control_proc__branch_function = 3'b100;
                               end
                           5'b00001 : 
                                   control_proc__branch_function = 3'b100;
                           5'b10010 : 
                               begin 
                                   control_proc__c_source = 3'b100;
                                   control_proc__pc_source = 2'b11;
                                   control_proc__branch_function = 3'b000;
                               end
                           5'b00010 : 
                               begin 
                                   control_proc__pc_source = 2'b11;
                                   control_proc__branch_function = 3'b000;
                               end
                           5'b10011 : 
                               begin 
                                   control_proc__c_source = 3'b100;
                                   control_proc__pc_source = 2'b11;
                                   control_proc__branch_function = 3'b100;
                               end
                           5'b00011 : 
                               begin 
                                   control_proc__pc_source = 2'b11;
                                   control_proc__branch_function = 3'b100;
                               end
                           default : 
                               ;
                       endcase
                   end
               6'b000011 : 
                   begin 
                       control_proc__c_source = 3'b100;
                       control_proc__rd = 6'b011111;
                       control_proc__pc_source = 2'b01;
                   end
               6'b000010 : 
                       control_proc__pc_source = 2'b01;
               6'b000100 : 
                   begin 
                       control_proc__a_source = 2'b10;
                       control_proc__b_source = 2'b11;
                       control_proc__alu_function = 4'b0001;
                       control_proc__pc_source = 2'b10;
                       control_proc__branch_function = 3'b010;
                   end
               6'b000101 : 
                   begin 
                       control_proc__a_source = 2'b10;
                       control_proc__b_source = 2'b11;
                       control_proc__alu_function = 4'b0001;
                       control_proc__pc_source = 2'b10;
                       control_proc__branch_function = 3'b011;
                   end
               6'b000110 : 
                   begin 
                       control_proc__a_source = 2'b10;
                       control_proc__b_source = 2'b11;
                       control_proc__alu_function = 4'b0001;
                       control_proc__pc_source = 2'b10;
                       control_proc__branch_function = 3'b001;
                   end
               6'b000111 : 
                   begin 
                       control_proc__a_source = 2'b10;
                       control_proc__b_source = 2'b11;
                       control_proc__alu_function = 4'b0001;
                       control_proc__pc_source = 2'b10;
                       control_proc__branch_function = 3'b101;
                   end
               6'b001000 : 
                   begin 
                       control_proc__b_source = 2'b10;
                       control_proc__c_source = 3'b001;
                       control_proc__rd = control_proc__rt;
                       control_proc__alu_function = 4'b0001;
                   end
               6'b001001 : 
                   begin 
                       control_proc__b_source = 2'b10;
                       control_proc__c_source = 3'b001;
                       control_proc__rd = control_proc__rt;
                       control_proc__alu_function = 4'b0001;
                   end
               6'b001010 : 
                   begin 
                       control_proc__b_source = 2'b10;
                       control_proc__c_source = 3'b001;
                       control_proc__rd = control_proc__rt;
                       control_proc__alu_function = 4'b0100;
                   end
               6'b001011 : 
                   begin 
                       control_proc__b_source = 2'b01;
                       control_proc__c_source = 3'b001;
                       control_proc__rd = control_proc__rt;
                       control_proc__alu_function = 4'b0011;
                   end
               6'b001100 : 
                   begin 
                       control_proc__b_source = 2'b01;
                       control_proc__c_source = 3'b001;
                       control_proc__rd = control_proc__rt;
                       control_proc__alu_function = 4'b0110;
                   end
               6'b001101 : 
                   begin 
                       control_proc__b_source = 2'b01;
                       control_proc__c_source = 3'b001;
                       control_proc__rd = control_proc__rt;
                       control_proc__alu_function = 4'b0101;
                   end
               6'b001110 : 
                   begin 
                       control_proc__b_source = 2'b01;
                       control_proc__c_source = 3'b001;
                       control_proc__rd = control_proc__rt;
                       control_proc__alu_function = 4'b0111;
                   end
               6'b001111 : 
                   begin 
                       control_proc__c_source = 3'b101;
                       control_proc__rd = control_proc__rt;
                   end
               6'b010000 : 
                   begin 
                       control_proc__alu_function = 4'b0101;
                       control_proc__c_source = 3'b001;
                       if ((opcode[23] === 1'b0)) 
                           begin 
                               control_proc__rs = {1'b1,opcode[15:11]};
                               control_proc__rt = 6'b000000;
                               control_proc__rd = {1'b0,opcode[20:16]};
                           end
                       else 
                           begin 
                               control_proc__rs = 6'b000000;
                               control_proc__rd[5] = 1'b1;
                           end

                       
                   end
               6'b010001: ;
               6'b010010: ;
               6'b010011: ;
               6'b010100 : 
                   begin 
                       control_proc__a_source = 2'b10;
                       control_proc__b_source = 2'b11;
                       control_proc__alu_function = 4'b0001;
                       control_proc__pc_source = 2'b11;
                       control_proc__branch_function = 3'b010;
                   end
               6'b010101 : 
                   begin 
                       control_proc__a_source = 2'b10;
                       control_proc__b_source = 2'b11;
                       control_proc__alu_function = 4'b0001;
                       control_proc__pc_source = 2'b11;
                       control_proc__branch_function = 3'b011;
                   end
               6'b010110 : 
                   begin 
                       control_proc__a_source = 2'b10;
                       control_proc__b_source = 2'b11;
                       control_proc__alu_function = 4'b0001;
                       control_proc__pc_source = 2'b11;
                       control_proc__branch_function = 3'b001;
                   end
               6'b010111 : 
                   begin 
                       control_proc__a_source = 2'b10;
                       control_proc__b_source = 2'b11;
                       control_proc__alu_function = 4'b0001;
                       control_proc__pc_source = 2'b11;
                       control_proc__branch_function = 3'b101;
                   end
               6'b100000 : 
                   begin 
                       control_proc__a_source = 2'b00;
                       control_proc__b_source = 2'b10;
                       control_proc__alu_function = 4'b0001;
                       control_proc__rd = control_proc__rt;
                       control_proc__c_source = 3'b010;
                       control_proc__mem_source = 4'b1110;
                   end
               6'b100001 : 
                   begin 
                       control_proc__a_source = 2'b00;
                       control_proc__b_source = 2'b10;
                       control_proc__alu_function = 4'b0001;
                       control_proc__rd = control_proc__rt;
                       control_proc__c_source = 3'b010;
                       control_proc__mem_source = 4'b1010;
                   end
               6'b100010 : 
                   begin 
                       control_proc__a_source = 2'b00;
                       control_proc__b_source = 2'b10;
                       control_proc__alu_function = 4'b0001;
                       control_proc__rd = control_proc__rt;
                       control_proc__c_source = 3'b010;
                       control_proc__mem_source = 4'b0100;
                   end
               6'b100011 : 
                   begin 
                       control_proc__a_source = 2'b00;
                       control_proc__b_source = 2'b10;
                       control_proc__alu_function = 4'b0001;
                       control_proc__rd = control_proc__rt;
                       control_proc__c_source = 3'b010;
                       control_proc__mem_source = 4'b0100;
                   end
               6'b100100 : 
                   begin 
                       control_proc__a_source = 2'b00;
                       control_proc__b_source = 2'b10;
                       control_proc__alu_function = 4'b0001;
                       control_proc__rd = control_proc__rt;
                       control_proc__c_source = 3'b010;
                       control_proc__mem_source = 4'b1100;
                   end
               6'b100101 : 
                   begin 
                       control_proc__a_source = 2'b00;
                       control_proc__b_source = 2'b10;
                       control_proc__alu_function = 4'b0001;
                       control_proc__rd = control_proc__rt;
                       control_proc__c_source = 3'b010;
                       control_proc__mem_source = 4'b1000;
                   end
               6'b100110: ;
               6'b101000 : 
                   begin 
                       control_proc__a_source = 2'b00;
                       control_proc__b_source = 2'b10;
                       control_proc__alu_function = 4'b0001;
                       control_proc__mem_source = 4'b1101;
                   end
               6'b101001 : 
                   begin 
                       control_proc__a_source = 2'b00;
                       control_proc__b_source = 2'b10;
                       control_proc__alu_function = 4'b0001;
                       control_proc__mem_source = 4'b1001;
                   end
               6'b101010 : 
                   begin 
                       control_proc__a_source = 2'b00;
                       control_proc__b_source = 2'b10;
                       control_proc__alu_function = 4'b0001;
                       control_proc__mem_source = 4'b0101;
                   end
               6'b101011 : 
                   begin 
                       control_proc__a_source = 2'b00;
                       control_proc__b_source = 2'b10;
                       control_proc__alu_function = 4'b0001;
                       control_proc__mem_source = 4'b0101;
                   end
               6'b101110: ;
               6'b101111: ;
               6'b110000: ;
               6'b110001: ;
               6'b110010: ;
               6'b110011: ;
               6'b110101: ;
               6'b110110: ;
               6'b110111: ;
               6'b111000: ;
               6'b111001: ;
               6'b111010: ;
               6'b111011: ;
               6'b111101: ;
               6'b111110: ;
               6'b111111 : 
                   ;
               default : 
                   ;
           endcase
           if ((control_proc__c_source === c_from_null)) 
               control_proc__rd = 6'b000000;
               
           if ((intr_signal === 1'b1)) 
               begin 
                   control_proc__rs = 6'b111111;
                   control_proc__rt = 6'b000000;
                   control_proc__rd = 6'b101110;
                   control_proc__alu_function = 4'b0101;
                   control_proc__shift_function = 2'b00;
                   control_proc__mult_function = 4'b0000;
                   control_proc__branch_function = 3'b110;
                   control_proc__a_source = 2'b00;
                   control_proc__b_source = 2'b00;
                   control_proc__c_source = 3'b011;
                   control_proc__pc_source = 2'b11;
                   control_proc__mem_source = 4'b0000;
               end
               
           rs_index <= control_proc__rs;
           rt_index <= control_proc__rt;
           rd_index <= control_proc__rd;
           imm_out <= control_proc__imm;
           alu_func <= control_proc__alu_function;
           shift_func <= control_proc__shift_function;
           mult_func <= control_proc__mult_function;
           branch_func <= control_proc__branch_function;
           a_source_out <= control_proc__a_source;
           b_source_out <= control_proc__b_source;
           c_source_out <= control_proc__c_source;
           pc_source_out <= control_proc__pc_source;
           mem_source_out <= control_proc__mem_source;
       end 
   end //always
    

endmodule
//-------------------------------------------------------------------
// TITLE: Bus Multiplexer / Signal Router
// AUTHOR: Steve Rhoads (rhoadss@yahoo.com)
// DATE CREATED: 2/8/01
// FILENAME: bus_mux.vhd
// PROJECT: Plasma CPU core
// COPYRIGHT: Software placed into the public domain by the author.
//    Software 'as is' without warranty.  Author liable for nothing.
// DESCRIPTION:
//    This entity is the main signal router.  
//    It multiplexes signals from multiple sources to the correct location.
//    The outputs are as follows:
//       a_bus        : goes to the ALU
//       b_bus        : goes to the ALU
//       reg_dest_out : goes to the register bank
//       take_branch  : goes to pc_next
//-------------------------------------------------------------------


module  bus_mux ( imm_in, reg_source, a_mux, a_out, reg_target, b_mux, b_out, c_bus, c_memory, c_pc, c_pc_plus4, c_mux, reg_dest_out, branch_func, take_branch );
         parameter [31:0] zero=32'b00000000000000000000000000000000;
     parameter [31:0] ones=32'b11111111111111111111111111111111;
     parameter [31:0] high_z=32'bZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ;
     parameter [3:0] alu_nothing=4'b0000;
     parameter [3:0] alu_add=4'b0001;
     parameter [3:0] alu_subtract=4'b0010;
     parameter [3:0] alu_less_than=4'b0011;
     parameter [3:0] alu_less_than_signed=4'b0100;
     parameter [3:0] alu_or=4'b0101;
     parameter [3:0] alu_and=4'b0110;
     parameter [3:0] alu_xor=4'b0111;
     parameter [3:0] alu_nor=4'b1000;
     parameter [1:0] shift_nothing=2'b00;
     parameter [1:0] shift_left_unsigned=2'b01;
     parameter [1:0] shift_right_signed=2'b11;
     parameter [1:0] shift_right_unsigned=2'b10;
     parameter [3:0] mult_nothing=4'b0000;
     parameter [3:0] mult_read_lo=4'b0001;
     parameter [3:0] mult_read_hi=4'b0010;
     parameter [3:0] mult_write_lo=4'b0011;
     parameter [3:0] mult_write_hi=4'b0100;
     parameter [3:0] mult_mult=4'b0101;
     parameter [3:0] mult_signed_mult=4'b0110;
     parameter [3:0] mult_divide=4'b0111;
     parameter [3:0] mult_signed_divide=4'b1000;
     parameter [1:0] a_from_reg_source=2'b00;
     parameter [1:0] a_from_imm10_6=2'b01;
     parameter [1:0] a_from_pc=2'b10;
     parameter [1:0] b_from_reg_target=2'b00;
     parameter [1:0] b_from_imm=2'b01;
     parameter [1:0] b_from_signed_imm=2'b10;
     parameter [1:0] b_from_immx4=2'b11;
     parameter [2:0] c_from_null=3'b000;
     parameter [2:0] c_from_alu=3'b001;
     parameter [2:0] c_from_shift=3'b001;
     parameter [2:0] c_from_mult=3'b001;
     parameter [2:0] c_from_memory=3'b010;
     parameter [2:0] c_from_pc=3'b011;
     parameter [2:0] c_from_pc_plus4=3'b100;
     parameter [2:0] c_from_imm_shift16=3'b101;
     parameter [2:0] c_from_reg_sourcen=3'b110;
     parameter [1:0] from_inc4=2'b00;
     parameter [1:0] from_opcode25_0=2'b01;
     parameter [1:0] from_branch=2'b10;
     parameter [1:0] from_lbranch=2'b11;
     parameter [2:0] branch_ltz=3'b000;
     parameter [2:0] branch_lez=3'b001;
     parameter [2:0] branch_eq=3'b010;
     parameter [2:0] branch_ne=3'b011;
     parameter [2:0] branch_gez=3'b100;
     parameter [2:0] branch_gtz=3'b101;
     parameter [2:0] branch_yes=3'b110;
     parameter [3:0] mem_fetch=4'b0000;
     parameter [3:0] mem_read32=4'b0100;
     parameter [3:0] mem_write32=4'b0101;
     parameter [3:0] mem_read16=4'b1000;
     parameter [3:0] mem_read16s=4'b1010;
     parameter [3:0] mem_write16=4'b1001;
     parameter [3:0] mem_read8=4'b1100;
     parameter [3:0] mem_read8s=4'b1110;
     parameter [3:0] mem_write8=4'b1101;

    input [15:0]  imm_in ;
    input [31:0]  reg_source ;
    input [1:0]  a_mux ;
    output [31:0]  a_out ;
    input [31:0]  reg_target ;
    input [1:0]  b_mux ;
    output [31:0]  b_out ;
    input [31:0]  c_bus ;
    input [31:0]  c_memory ;
    input [31:0]  c_pc ;
    input [31:0]  c_pc_plus4 ;
    input [2:0]  c_mux ;
    output [31:0]  reg_dest_out ;
    input [2:0]  branch_func ;
    output take_branch;


    reg pc_mux__is_equal;
    reg [31:0] a_out;
    reg [31:0] b_out;
    reg [31:0] reg_dest_out;
    reg take_branch;


    
       
   always @ (reg_source or imm_in or a_mux or c_pc ) begin
       begin 
           case (a_mux)
               2'b00 : 
                       a_out <= reg_source;
               2'b01 : 
                   begin 
                       a_out[31:5] <= zero[31:5];
                       a_out[4:0] <= imm_in[10:6];
                   end
               default : 
                       a_out <= c_pc;
           endcase
       end 
   end //always
   
       
   always @ (reg_target or imm_in or b_mux ) begin
       begin 
           case (b_mux)
               2'b00 : 
                       b_out <= reg_target;
               2'b01 : 
                       b_out <= {zero[31:16],imm_in};
               2'b10 : 
                   begin 
                       if ((imm_in[15] === 1'b0)) 
                               b_out[31:16] <= zero[31:16];
                       else 
                               b_out[31:16] <= 16'b1111111111111111;

                       b_out[15:0] <= imm_in;
                   end
               default : 
                   begin 
                       if ((imm_in[15] === 1'b0)) 
                               b_out[31:18] <= 14'b00000000000000;
                       else 
                               b_out[31:18] <= 14'b11111111111111;

                       b_out[17:0] <= {imm_in,2'b00};
                   end
           endcase
       end 
   end //always
   
       
   always @ (c_bus or c_memory or c_pc or c_pc_plus4 or imm_in or c_mux ) begin
       begin 
           case (c_mux)
               3'b001 : 
                       reg_dest_out <= c_bus;
               3'b010 : 
                       reg_dest_out <= c_memory;
               3'b011 : 
                       reg_dest_out <= {c_pc[31:3],3'b000};
               3'b100 : 
                       reg_dest_out <= c_pc_plus4;
               3'b101 : 
                       reg_dest_out <= {imm_in,zero[15:0]};
               default : 
                       reg_dest_out <= c_bus;
           endcase
       end 
   end //always
   
       
   always @ (branch_func or reg_source or reg_target ) begin
       begin 
           if ((reg_source === reg_target)) 
               pc_mux__is_equal = 1'b1;
               
           else 
               pc_mux__is_equal = 1'b0;
               
           case (branch_func)
               3'b000 : 
                       take_branch <= reg_source[31];
               3'b001 : 
                       take_branch <= (reg_source[31] | pc_mux__is_equal);
               3'b010 : 
                       take_branch <= pc_mux__is_equal;
               3'b011 : 
                       take_branch <= ~ (pc_mux__is_equal);
               3'b100 : 
                       take_branch <= ~ (reg_source[31]);
               3'b101 : 
                       take_branch <= (~ (reg_source[31]) & ~ (pc_mux__is_equal));
               3'b110 : 
                       take_branch <= 1'b1;
               default : 
                       take_branch <= pc_mux__is_equal;
           endcase
       end 
   end //always
    

endmodule
//-------------------------------------------------------------------
// TITLE: Arithmetic Logic Unit
// AUTHOR: Steve Rhoads (rhoadss@yahoo.com)
// DATE CREATED: 2/8/01
// FILENAME: alu.vhd
// PROJECT: Plasma CPU core
// COPYRIGHT: Software placed into the public domain by the author.
//    Software 'as is' without warranty.  Author liable for nothing.
// DESCRIPTION:
//    Implements the ALU.
//-------------------------------------------------------------------


module  alu ( a_in, b_in, alu_function, c_alu );
parameter adder_type="GENERIC";
parameter alu_type="GENERIC";
         parameter [31:0] zero=32'b00000000000000000000000000000000;
     parameter [31:0] ones=32'b11111111111111111111111111111111;
     parameter [31:0] high_z=32'bZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ;
     parameter [3:0] alu_nothing=4'b0000;
     parameter [3:0] alu_add=4'b0001;
     parameter [3:0] alu_subtract=4'b0010;
     parameter [3:0] alu_less_than=4'b0011;
     parameter [3:0] alu_less_than_signed=4'b0100;
     parameter [3:0] alu_or=4'b0101;
     parameter [3:0] alu_and=4'b0110;
     parameter [3:0] alu_xor=4'b0111;
     parameter [3:0] alu_nor=4'b1000;
     parameter [1:0] shift_nothing=2'b00;
     parameter [1:0] shift_left_unsigned=2'b01;
     parameter [1:0] shift_right_signed=2'b11;
     parameter [1:0] shift_right_unsigned=2'b10;
     parameter [3:0] mult_nothing=4'b0000;
     parameter [3:0] mult_read_lo=4'b0001;
     parameter [3:0] mult_read_hi=4'b0010;
     parameter [3:0] mult_write_lo=4'b0011;
     parameter [3:0] mult_write_hi=4'b0100;
     parameter [3:0] mult_mult=4'b0101;
     parameter [3:0] mult_signed_mult=4'b0110;
     parameter [3:0] mult_divide=4'b0111;
     parameter [3:0] mult_signed_divide=4'b1000;
     parameter [1:0] a_from_reg_source=2'b00;
     parameter [1:0] a_from_imm10_6=2'b01;
     parameter [1:0] a_from_pc=2'b10;
     parameter [1:0] b_from_reg_target=2'b00;
     parameter [1:0] b_from_imm=2'b01;
     parameter [1:0] b_from_signed_imm=2'b10;
     parameter [1:0] b_from_immx4=2'b11;
     parameter [2:0] c_from_null=3'b000;
     parameter [2:0] c_from_alu=3'b001;
     parameter [2:0] c_from_shift=3'b001;
     parameter [2:0] c_from_mult=3'b001;
     parameter [2:0] c_from_memory=3'b010;
     parameter [2:0] c_from_pc=3'b011;
     parameter [2:0] c_from_pc_plus4=3'b100;
     parameter [2:0] c_from_imm_shift16=3'b101;
     parameter [2:0] c_from_reg_sourcen=3'b110;
     parameter [1:0] from_inc4=2'b00;
     parameter [1:0] from_opcode25_0=2'b01;
     parameter [1:0] from_branch=2'b10;
     parameter [1:0] from_lbranch=2'b11;
     parameter [2:0] branch_ltz=3'b000;
     parameter [2:0] branch_lez=3'b001;
     parameter [2:0] branch_eq=3'b010;
     parameter [2:0] branch_ne=3'b011;
     parameter [2:0] branch_gez=3'b100;
     parameter [2:0] branch_gtz=3'b101;
     parameter [2:0] branch_yes=3'b110;
     parameter [3:0] mem_fetch=4'b0000;
     parameter [3:0] mem_read32=4'b0100;
     parameter [3:0] mem_write32=4'b0101;
     parameter [3:0] mem_read16=4'b1000;
     parameter [3:0] mem_read16s=4'b1010;
     parameter [3:0] mem_write16=4'b1001;
     parameter [3:0] mem_read8=4'b1100;
     parameter [3:0] mem_read8s=4'b1110;
     parameter [3:0] mem_write8=4'b1101;

    input [31:0]  a_in ;
    input [31:0]  b_in ;
    input [3:0]  alu_function ;
    output [31:0]  c_alu ;


    wire [32:0] aa;
    wire [32:0] bb;
    wire [32:0] sum;
    wire do_add;
    wire sign_ext;
    wire [31:0] c_alu;


    
   assign {do_add}=(alu_function === alu_add) ? 
                       1'b1
                    :  1'b0;
   
   assign {sign_ext}=(alu_function === alu_less_than) ? 
                         1'b0
                      :  1'b1;
   
   assign {aa}={(a_in[31] & sign_ext),a_in};
   
   assign {bb}={(b_in[31] & sign_ext),b_in};
   
   
   generate
       if ((alu_type === "GENERIC"))begin//generate if 
               
           assign {c_alu}=((alu_function === alu_add) | (alu_function === alu_subtract)) ? 
                              sum[31:0]
                           : ((alu_function === alu_less_than) | (alu_function === alu_less_than_signed)) ? 
                              {zero[31:1],sum[32]}
                           : (alu_function === alu_or) ? 
                              (a_in | b_in)
                           : (alu_function === alu_and) ? 
                              (a_in & b_in)
                           : (alu_function === alu_xor) ? 
                              (a_in ^ b_in)
                           : (alu_function === alu_nor) ? 
                              (~(a_in | b_in))
                           :  32'b00000000000000000000000000000000;
           
       end//generate if
   endgenerate
   
   
   generate
       if ((alu_type === "AREA_OPTIMIZED"))begin//generate if 
               
           assign {c_alu}=((alu_function === alu_add) | (alu_function === alu_subtract)) ? 
                              sum[31:0]
                           :  {(31-0+1- 0){1'bz}};
           
           assign {c_alu}=((alu_function === alu_less_than) | (alu_function === alu_less_than_signed)) ? 
                              {zero[31:1],sum[32]}
                           :  {(31-0+1- 0){1'bz}};
           
           assign {c_alu}=(alu_function === alu_or) ? 
                              (a_in | b_in)
                           :  {(31-0+1- 0){1'bz}};
           
           assign {c_alu}=(alu_function === alu_and) ? 
                              (a_in & b_in)
                           :  {(31-0+1- 0){1'bz}};
           
           assign {c_alu}=(alu_function === alu_xor) ? 
                              (a_in ^ b_in)
                           :  {(31-0+1- 0){1'bz}};
           
           assign {c_alu}=(alu_function === alu_nor) ? 
                              (~(a_in | b_in))
                           :  {(31-0+1- 0){1'bz}};
           
           assign {c_alu}=(alu_function === alu_nothing) ? 
                              32'b00000000000000000000000000000000
                           :  {(31-0+1- 0){1'bz}};
           
       end//generate if
   endgenerate
   
   
   generate
       if ((adder_type === "GENERIC"))begin//generate if 
               
           assign {sum}=bv_adder__0(aa, bb, do_add);
           
       end//generate if
   endgenerate
   
   
   generate
       if ((adder_type === "ALTERA"))begin//generate if 
               
           lpm_add_sub  #(.lpm_width(33),.lpm_direction("UNUSED"),.lpm_type("LPM_ADD_SUB"),.lpm_hint("ONE_INPUT_IS_CONSTANT=NO")) lpm_add_sub_component(.dataa(aa), .add_sub(do_add), .datab(bb), .result(sum));
           //Parameter Order: lpm_width,lpm_direction,lpm_type,lpm_hint 
       end//generate if
   endgenerate
    
    function [32:0] bv_adder__0;
        input [32:0]  a ;
        input [32:0]  b ;
        input  do_add ;
        reg carry_in;
        reg [32:0] bb;
        reg [32:0] result;
        begin : Function
            begin 
                result = {1'b0, 1'b0, 1'b0, 1'b0, 1'b0, 1'b0, 1'b0, 1'b0, 1'b0, 1'b0, 1'b0, 1'b0, 1'b0, 1'b0, 1'b0, 1'b0, 1'b0, 1'b0, 1'b0, 1'b0, 1'b0, 1'b0, 1'b0, 1'b0, 1'b0, 1'b0, 1'b0, 1'b0, 1'b0, 1'b0, 1'b0, 1'b0, 1'b0/*aggregate*/};
                if ((do_add === 1'b1)) 
                    begin 
                        bb = b;
                        carry_in = 1'b0;
                    end
                else 
                    begin 
                        bb = ~ (b);
                        carry_in = 1'b1;
                    end

                begin :Block_Name_1
                    integer index;
                    for (index=0;index<=32;index=index+1) begin 
                        begin 
                            result[index] = ((a[index] ^ bb[index]) ^ carry_in);
                            carry_in = ((carry_in & (a[index] | bb[index])) | (a[index] & bb[index]));
                        end
                        
                    end //for
                end //end Block
                begin 
                    bv_adder__0=result;
                    disable Function;
                end
            end
        end // Function
    endfunction
        

    

endmodule
//-------------------------------------------------------------------
// TITLE: UART
// AUTHOR: Steve Rhoads (rhoadss@yahoo.com)
// DATE CREATED: 5/29/02
// FILENAME: uart.vhd
// PROJECT: Plasma CPU core
// COPYRIGHT: Software placed into the public domain by the author.
//    Software 'as is' without warranty.  Author liable for nothing.
// DESCRIPTION:
//    Implements the UART.
//    Stalls the CPU until the charater has been transmitted.
//-------------------------------------------------------------------


module  uart ( clk, reset, uart_sel, data, uart_read, uart_write, pause );
parameter log_file="UNUSED";
    //type strength
     parameter strn_x01__strength=4'd0;
     parameter strn_x0h__strength=4'd1;
     parameter strn_xl1__strength=4'd2;
     parameter strn_x0z__strength=4'd3;
     parameter strn_xz1__strength=4'd4;
     parameter strn_wlh__strength=4'd5;
     parameter strn_wlz__strength=4'd6;
     parameter strn_wzh__strength=4'd7;
     parameter strn_w0h__strength=4'd8;
     parameter strn_wl1__strength=4'd9;
     
 parameter [31:0] zero=32'b00000000000000000000000000000000;
 parameter [31:0] ones=32'b11111111111111111111111111111111;
 parameter [31:0] high_z=32'bZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ;
 parameter [3:0] alu_nothing=4'b0000;
 parameter [3:0] alu_add=4'b0001;
 parameter [3:0] alu_subtract=4'b0010;
 parameter [3:0] alu_less_than=4'b0011;
 parameter [3:0] alu_less_than_signed=4'b0100;
 parameter [3:0] alu_or=4'b0101;
 parameter [3:0] alu_and=4'b0110;
 parameter [3:0] alu_xor=4'b0111;
 parameter [3:0] alu_nor=4'b1000;
 parameter [1:0] shift_nothing=2'b00;
 parameter [1:0] shift_left_unsigned=2'b01;
 parameter [1:0] shift_right_signed=2'b11;
 parameter [1:0] shift_right_unsigned=2'b10;
 parameter [3:0] mult_nothing=4'b0000;
 parameter [3:0] mult_read_lo=4'b0001;
 parameter [3:0] mult_read_hi=4'b0010;
 parameter [3:0] mult_write_lo=4'b0011;
 parameter [3:0] mult_write_hi=4'b0100;
 parameter [3:0] mult_mult=4'b0101;
 parameter [3:0] mult_signed_mult=4'b0110;
 parameter [3:0] mult_divide=4'b0111;
 parameter [3:0] mult_signed_divide=4'b1000;
 parameter [1:0] a_from_reg_source=2'b00;
 parameter [1:0] a_from_imm10_6=2'b01;
 parameter [1:0] a_from_pc=2'b10;
 parameter [1:0] b_from_reg_target=2'b00;
 parameter [1:0] b_from_imm=2'b01;
 parameter [1:0] b_from_signed_imm=2'b10;
 parameter [1:0] b_from_immx4=2'b11;
 parameter [2:0] c_from_null=3'b000;
 parameter [2:0] c_from_alu=3'b001;
 parameter [2:0] c_from_shift=3'b001;
 parameter [2:0] c_from_mult=3'b001;
 parameter [2:0] c_from_memory=3'b010;
 parameter [2:0] c_from_pc=3'b011;
 parameter [2:0] c_from_pc_plus4=3'b100;
 parameter [2:0] c_from_imm_shift16=3'b101;
 parameter [2:0] c_from_reg_sourcen=3'b110;
 parameter [1:0] from_inc4=2'b00;
 parameter [1:0] from_opcode25_0=2'b01;
 parameter [1:0] from_branch=2'b10;
 parameter [1:0] from_lbranch=2'b11;
 parameter [2:0] branch_ltz=3'b000;
 parameter [2:0] branch_lez=3'b001;
 parameter [2:0] branch_eq=3'b010;
 parameter [2:0] branch_ne=3'b011;
 parameter [2:0] branch_gez=3'b100;
 parameter [2:0] branch_gtz=3'b101;
 parameter [2:0] branch_yes=3'b110;
 parameter [3:0] mem_fetch=4'b0000;
 parameter [3:0] mem_read32=4'b0100;
 parameter [3:0] mem_write32=4'b0101;
 parameter [3:0] mem_read16=4'b1000;
 parameter [3:0] mem_read16s=4'b1010;
 parameter [3:0] mem_write16=4'b1001;
 parameter [3:0] mem_read8=4'b1100;
 parameter [3:0] mem_read8s=4'b1110;
 parameter [3:0] mem_write8=4'b1101;

    input clk;
    input reset;
    input uart_sel;
    input [7:0]  data ;
    input uart_read;
    output uart_write;
    output pause;


parameter [9:0] uart_proc__div_value=10'b0100011110;
    reg [8:0] uart_proc__data_next;
    reg [3:0] uart_proc__bits_next;
    reg [9:0] uart_proc__div_next;
    reg [8:0] data_reg;
    reg [3:0] bits_reg;
    reg [9:0] div_reg;
    reg uart_write;
    reg pause;


    
   always @ (posedge clk or posedge reset ) begin
       if ((reset === 1'b1)) 
           begin 
               data_reg <= zero[8:0];
               bits_reg <= 4'b0000;
               div_reg <= zero[9:0];
           end
           
       else 
           begin 
               data_reg <= uart_proc__data_next;
               bits_reg <= uart_proc__bits_next;
               div_reg <= uart_proc__div_next;
           end
           
       
   end //always
       
   always @ (clk or reset or data_reg or bits_reg or div_reg or uart_sel or data ) begin
       begin 
           uart_proc__data_next = data_reg;
           uart_proc__bits_next = bits_reg;
           uart_proc__div_next = div_reg;
           if ((uart_sel === 1'b1)) 
               begin 
                   uart_proc__data_next = {data,1'b0};
                   uart_proc__bits_next = 4'b1010;
                   uart_proc__div_next = zero[9:0];
               end
               
           else if ((div_reg === uart_proc__div_value)) 
               begin 
                   uart_proc__data_next = {1'b1,data_reg[8:1]};
                   if ((!(bits_reg===4'b0000))) 
                       uart_proc__bits_next = (bits_reg - 1);
                       
                   
                   uart_proc__div_next = zero[9:0];
               end
               
           else 
               uart_proc__div_next = (div_reg + 1);
               
           uart_write <= data_reg[0];
           if ((((uart_sel === 1'b0) & (!(bits_reg===4'b0000))) & (log_file === "UNUSED"))) 
               pause <= 1'b1;
               
           else 
               pause <= 1'b0;
               
           
       end 
   end //always
   
   
   generate
       if ((!(log_file==="UNUSED")))begin//generate if 
               integer uart_proc__store_file;
   initial begin
           uart_proc__store_file=$fopen(log_file,"w");
   end
line_vhdl uart_proc__hex_file_line;
reg [7:0] uart_proc__c;
    integer uart_proc__index;
    integer uart_proc__line_length = 0;
               
           always @ (posedge clk ) begin
                   begin 
                       if ((uart_sel === 1'b1)) 
                           begin 
                               uart_proc__index = data[6:0];
                               if ((!(uart_proc__index===10))) 
                                   begin 
                                       uart_proc__c = uart_proc__index;
                                       $write_character(uart_proc__hex_file_line, uart_proc__c, /*open*/, /*open*/);
                                       uart_proc__line_length = (uart_proc__line_length + 1);
                                   end
                                   
                               
                               if (((uart_proc__index === 10) | (uart_proc__line_length >= 72))) 
                                   begin 
                                       $writeline(uart_proc__store_file, uart_proc__hex_file_line);
                                       uart_proc__line_length = 0;
                                   end
                                   
                               
                               
                           end
                           
                       
                       
                   end 
               
           end //always
               
       end//generate if
   endgenerate
                                           
                                       
endmodule
